﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using Produmex.Foundation;
using Produmex.Foundation.Barcode;
using Produmex.Foundation.Convertors;
using Produmex.Foundation.Data;
using Produmex.Foundation.Data.DbClient;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Foundation.Data.Sbo.Generators.BarcodeController;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Messages;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.SlimScreen.Interfaces;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.SlimScreen.WinGui;
using Produmex.Foundation.Utilities;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using Produmex.Foundation.Wwf.Sbo.LocalServices;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data.ViewObjects;
using Produmex.Sbo.Logex.Data.ViewObjects.Definitions.Views;
using System.Data.Common;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.Data.DataSetClient;
using Produmex.Foundation.GS1;

// PmxWorkflowExecutionTypes.SUB_FLOW
namespace WorkflowScript_ReceptionStoneMedicalScript
{
    public class WorkflowScript_ReceptionStoneMedicalScript : WorkflowInstanceScriptBase
    {
        public WorkflowScript_ReceptionStoneMedicalScript(WorkflowInstanceBase parent, WorkflowInstanceFactory factory) : base(parent, factory)
        {

            m_enterQuantitySubFlow = this.Create("EnterQuantityScript");
        }

        // Input parameters
        public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
        public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;


        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);
        private WorkflowInstanceBase m_enterQuantitySubFlow;
        private Collection<string> m_subFlowListOfSerialNumbers;

        /// <summary>
        /// The m_print item label flow
        /// </summary>
        private WorkflowInstanceBase m_printItemLabelFlow;
        /// <summary>
        /// The m_print item label flow_ back requested
        /// </summary>
        private bool m_printItemLabelFlow_BackRequested = false;

        /// <summary>
        /// The m_print item label flow_ location code
        /// </summary>
        private string m_printItemLabelFlow_LocationCode;
        /// <summary>
        /// The m_print item label flow_ needed item code
        /// </summary>
        private string m_printItemLabelFlow_NeededItemCode;
        /// <summary>
        /// The m_print item label flow_ needed packaging type
        /// </summary>
        private string m_printItemLabelFlow_NeededPackagingType;

        private int? m_printItemLabelFlow_NeededQuantityByPackagingType;


        /// <summary>
        /// The m_print item label flow_ needed batch number
        /// </summary>
        private string m_printItemLabelFlow_NeededBatchNumber;
        /// <summary>
        /// The m_print item label flow_ needed batch number2
        /// </summary>
        private string m_printItemLabelFlow_NeededBatchNumber2;
        /// <summary>
        /// The m_print item label flow_ needed best before date
        /// </summary>
        private DateTime? m_printItemLabelFlow_NeededBestBeforeDate;
        /// <summary>
        /// The m_print item label flow_ needed nr of labels
        /// </summary>
        private int? m_printItemLabelFlow_NeededNrOfLabels;
        /// <summary>
        /// The m_print item label flow_ entered quantity
        /// </summary>
        private double? m_printItemLabelFlow_EnteredQuantity;

        private double? m_printItemLabelFlow_EnteredQuantityUom2;
        private bool m_printItemLabelFlow_ShowPrintMessage;

        protected bool m_subFlowBackRequested;

        protected double m_subFlowQuantity;
        private bool askUserToPrintLabels;
        private BuildQuery.LocationFilter selectLocationFilter;
        private object defaultLocationCode;
        private string dstLocationCode;
        private LogisticUnitGoodsReceipt currentLogUnit;

        private bool receiveAfterLocationScan;

        private class LogisticUnitItemGoodReceiptForSO: LogisticUnitItemGoodReceipt
        {

            public string CardCode { get; set; }
            public string CardName { get; set; }
            public int SODocEntry { get; set; }

            public int SODocLine { get; set; }

            public int? ItemTransactionalInfoKey { get; internal set; }
        }

        private static class Definitions
        {
            //report definitions
            public const string REPORT_PATH_PO_REPORT = @"StoneMedicalPOReport.rpt";
            public const int NUMBER_OF_PO_REPORT = 1;

            /// <summary>
            /// The separator for separating strings values
            /// </summary>
            public const string SEPARATOR = ", ";
        }


        private Collection<DocumentLineRef> soLineReferences = new Collection<DocumentLineRef>();

        //private class LogisticUnitItemGoodReceiptWithPoSoLink : LogisticUnitItemGoodReceipt 
        //{
        //    public DocumentRef SalesDocRef { get; set; }

        //    public int? SalesDocumentLineNumber { get; set; }

        //    public double SalesDocumentLineQuantity { get; set; }
        //}


        #region WorkflowInstanceScriptBase Members

        protected override void Execute()
        {
            Session session = GetScopeParameter("Session") as Session;
            ISboProviderService sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;

            string initialErrorKey = null;
            Message msg;
            ProdumexError pmxError = null;
            IBarcodeController barcodeController = null;
            string query = null;
            Collection<PackagingTypeInfo> listOfPackagingTypeInfosForScreen = null;

            Collection<ItemTransactionalPackagingTypeInfo> currentListOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();

            string deviceID = session.DeviceInstanceId;
            PmxOseWarehouseInfo whsInfoDevice = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), deviceID);
            bool goBack = false;
            string dockCode = null;

            PmxOseWarehouseInfo whsInfo = null;
            DocumentRef purchaseDocRef = null;
            string cardCode = null;
            int? purchaseOrderDocNum = null;

            string remarksViewName = string.Empty;
            DataSet ds = null;

            bool allowToSelectBatch = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteGetAllowToSelectBatches));


            string customerCode = null;
            string customerName = null;
            string customerAddress = null;
            string itemCode = null;
            string itemDescription = null;
            PmxItemInfo itemInfo = null;
            double? numberOfItemsInPurchaseUnit = null;
            string purchaseUom = null;
            DataSet dsItems = null;

            List<string> buttonList = null;
            string gtin = null;

            int? purchaseOrderLineNum = null;

            int? salesOrderLineNum = null;
            int? salesOrderDocEntry = null;
            double stillToReceiveQuantity = 0;

            int? targetLuid = null;
            string targetSSCC = null;

            DataSet dsCustomers = null;

            string batchNumber = null;
            string secondBatchNumber = null;
            DateTime? bestBeforeDate = null;

            double quantity = 0;
            double? quantityUom2 = null;

            bool askForPieces = false;
            bool askForWeight = false;

            GeneratedBestBeforeDateReception generatedBBDInfo = null;

            Collection<string> listOfSerialNumbers = new Collection<string>();

            double initialQuantity;

            int? numberOfItemLabels = 0;

            bool proceed = false;
            bool askReprint;
            string targetStorLocCode = null;

            Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();

            //initialize sub flows
            m_printItemLabelFlow = Create("PrintItemLabelScript");
            m_printItemLabelFlow.BindParameters(
                this.DefaultCultureInfo,
                this.PmxOseCompany,
                new ReadOnlyBinder<string>("LocationCode", this, "m_printItemLabelFlow_LocationCode"),
                new ReadOnlyBinder<string>("NeededItemCode", this, "m_printItemLabelFlow_NeededItemCode"),
                new ReadOnlyBinder<string>("NeededPackagingType", this, "m_printItemLabelFlow_NeededPackagingType"),
                new ReadOnlyBinder<int?>("NeededQuantityByPackagingType", this, "m_printItemLabelFlow_NeededQuantityByPackagingType"),
                new ReadOnlyBinder<string>("NeededBatchNumber", this, "m_printItemLabelFlow_NeededBatchNumber"),
                new ReadOnlyBinder<string>("NeededBatchNumber2", this, "m_printItemLabelFlow_NeededBatchNumber2"),
                new ReadOnlyBinder<DateTime?>("NeededBestBeforeDate", this, "m_printItemLabelFlow_NeededBestBeforeDate"),
                new ReadOnlyBinder<int?>("NeededNrOfLabels", this, "m_printItemLabelFlow_NeededNrOfLabels"),
                new ReadWriteBinder<bool>("BackRequested", this, "m_printItemLabelFlow_BackRequested"),
                new ReadWriteBinder<double?>("EnteredQuantity", this, "m_printItemLabelFlow_EnteredQuantity"),
                new ReadWriteBinder<double?>("EnteredQuantityUom2", this, "m_printItemLabelFlow_EnteredQuantityUom2"),
                new ReadWriteBinder<bool>("ShowPrintMessage", this, "m_printItemLabelFlow_ShowPrintMessage"));

            bool allowToExceedOrderedQuantity = true;
            sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null,
            delegate (PmxDbConnection conn, object[] parameters)
            {
                PmxBarcodeProvider bcProv = new PmxBarcodeProvider(conn);
                barcodeController = bcProv.GetBarcodeController();

                PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider();
                Dictionary<string, PmxParameterValue> pdParams = prov.GetParametersPurchaseOrderGenerator(conn);

                askUserToPrintLabels = PmxParameterValueProvider.GetParameterValue<bool>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_ASK_TO_PRINT_LABEL, false);
                remarksViewName = PmxParameterValueProvider.GetParameterValue<string>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_REMARKS_VIEW_NAME, string.Empty);

                allowToExceedOrderedQuantity = PmxParameterValueProvider.GetParameterValue<bool>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_ALLOW_TO_EXCEED_ORDERED_QTY, true);

                return null;
            });




        Step_SelectDock:

            #region SELECT DOCK

            // Get locations
            query = BuildQuery.GetCodeNameDockOrderByName(true, true, true, whsInfoDevice.PmxWarehouseCode, deviceID);
            DataSet dsDocks = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsDocks) == 1 && !goBack)
            {
                dockCode = Convert.ToString(dsDocks.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name]);
                //reset warehouse info
                whsInfo = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), dockCode);
                goto Step_SelectOrder;
            }
            goBack = false;

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_LOCATION",
                "LocationDS", dsDocks
                ));

            msg = WaitForMessage();
            goBack = false;
            initialErrorKey = null;
            if (msg.Name.EndsWith(".LocationSelected"))
            {
                dockCode = ExtractParameter<string>(msg.Parameters, "locationCode");
                //reset warehouse info
                whsInfo = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), dockCode);

                goto Step_SelectOrder;
            }

            if (msg.Name.EndsWith(".RefreshRequested"))
            {
                goto Step_SelectDock;
            }

            //back requested
            return;

        #endregion


        Step_SelectOrder:

            #region SELECT ORDER


            purchaseDocRef = null;

            query = BuildQuery.GetPOsOrderByPONumber(null, null, whsInfo.SboWarehouseCode, sboProviderService.GetDbTool());
            DataSet dsPurchaseOrders = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsPurchaseOrders) == 0)
            {
                initialErrorKey = "MSG_ERROR_NO_PO_FOUND";

                goBack = true;
                goto Step_SelectDock;
            }

            if (this.GetNumberOfRows(dsPurchaseOrders) == 1 &&
                !goBack)
            {
                DataRow row = dsPurchaseOrders.Tables[0].Rows[0];

                //we found just one row, and we do not want to select it manually, so auto-select
                purchaseDocRef = new DocumentRef(Convert.ToString(row[PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name]), Convert.ToInt32(row[PurchaseOrderDataSet.Columns.PO_ID.Name]));
                cardCode = Convert.ToString(row[PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(row[PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                goto Step_ShowRemarks;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectPOScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_PO",
                "ButtonKey", "",
                "PODS", dsPurchaseOrders,
                 "BarcodeController", barcodeController
                ));

            msg = WaitForMessage();
            goBack = false;
            initialErrorKey = null;
            if (msg.Name.EndsWith(".POSelected"))
            {
                purchaseDocRef = new DocumentRef(ExtractParameter<string>(msg.Parameters, "docObjType"), ExtractParameter<int>(msg.Parameters, "docEntry"));

                DataRow[] rows = dsPurchaseOrders.Tables[0].Select(PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name + " = " + purchaseDocRef.DocType
                    + " AND " + PurchaseOrderDataSet.Columns.PO_ID.Name + " = " + purchaseDocRef.DocEntry.ToString());

                if (rows.Length > 0)
                {
                    cardCode = Convert.ToString(rows[0][PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                    purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(rows[0][PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                }


                goto Step_ShowRemarks;
            }

            if (msg.Name.EndsWith("ISelectPOScreenReply.RefreshRequested"))
            {
                goto Step_SelectOrder;
            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                //Not possible
                goto Step_SelectOrder;
            }

            goBack = true;
            goto Step_SelectDock;

        #endregion

        Step_ShowRemarks:

            #region SHOW REMARKS

            if (!string.IsNullOrEmpty(remarksViewName) && purchaseDocRef != null)
            {
                query = BuildQuery.GetRemarks(purchaseDocRef.DocEntry, purchaseDocRef.DocType, remarksViewName, sboProviderService.GetDbTool());
                ds = sboProviderService.RunView(true, null, null, query);

                if (this.GetNumberOfRows(ds) > 0)
                {

                    ds.Tables[0].Columns.Remove(PmxDocumentLineLockTable.Columns.ObjType.NAME);
                    ds.Tables[0].Columns.Remove(PmxDocumentLineLockTable.Columns.DocEntry.NAME);

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowRemarksScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "RemarksTable", ds.Tables[0],
                            "EnabledToolBarButtons", ToolBarButtons.Forward));
                    WaitForMessage();
                }
            }

            goto Step_PrintPOReport;

        #endregion

        Step_PrintPOReport:

            #region PRINT PO REPORT

            string msgKey = null;

            try
            {

                sboProviderService.InvokeMethodWithDbConnection<PmxOsePrinter>(false, false, null, null,
                delegate (PmxDbConnection conn, object[] parameters)
                {
                    PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);

                    Collection<ReportParameter> reportParameters = new Collection<ReportParameter>();
                    reportParameters.Add(new ReportParameter("@poDocEntry", purchaseDocRef.DocEntry));

                    return prov.PrintReport(reportParameters, Definitions.REPORT_PATH_PO_REPORT, Definitions.NUMBER_OF_PO_REPORT, deviceID, dockCode, false);
                });


                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "MessageKey", "MSG_QUESTION_REPRINT_LABEL",
                        "TitleKey", "MSG_TITLE_REPRINT_LABEL"));

                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_PrintPOReport;
                }
            }
            catch (ProdumexException ex)
            {
                s_log.Error("", ex);
                msgKey = ExceptionHelper.Format(ex, this.DefaultCultureInfo);
                pmxError = ex.Error;
            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
                msgKey = ExceptionHelper.Format(ex, this.DefaultCultureInfo);
            }

            if (msgKey != null)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", null,
                        "MessageKey", msgKey,
                        "PmxError", pmxError,
                        "ShowButton", true));
                WaitForMessage();
            }

            goto Step_StartReceiving;


        #endregion

        Step_StartReceiving:

            #region START RECEIVING

            //TODO: Initialize list that will be used to book the receipt

            customerCode = null;
            customerAddress = null;
			targetLuid = null;
			targetSSCC = null;
			targetStorLocCode = null;

			string customerInfo = null;

            if (purchaseDocRef != null)
            {
                query = BuildQuery.GetCustomerInfo(purchaseDocRef.DocEntry, purchaseDocRef.DocType, sboProviderService.GetDbTool());
                DataSet dsCustomerInfo = sboProviderService.RunView(false, null, null, query);

                customerInfo = GetCustomerInfo(dsCustomerInfo);
            }

            currentLogUnit = new LogisticUnitGoodsReceipt();
            purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();
            soLineReferences = new Collection<DocumentLineRef>();

			string titleKey = "MSG_TITLE_SCAN_GS1_LABEL";
			List<string> allowedButtonsForLabelScreen = new List<string>();
			allowedButtonsForLabelScreen.Add("MSG_BUTTON_NO_LABEL");


			BarcodeContainer barcode = null;

			goto Step_ScanLabel;

			#endregion


			Step_ScanLabel:

			#region SCAN LABEL

			targetLuid = null;
			targetSSCC = null;
			targetStorLocCode = null;

			session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
			DefaultCultureInfo.Get(), BuildParamCollection(
				"InitialErrorKey", initialErrorKey,
				"TitleKey", titleKey,
				"BarcodeController", barcodeController,
				"ImageType", GS1ImageType.PalletImage,
				"AllowedButtons", allowedButtonsForLabelScreen.ToArray(),
				"GS1DataObject", barcode == null ? null : barcode.GS1DataObject
				));
			goBack = false;
			msg = WaitForMessage();
			// Reset latest error
			initialErrorKey = null;

			if (msg.Name.EndsWith(".DataEntered"))
			{
				barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

				if (this.IsSSCCOnBarcode(barcode.GS1DataObject))
				{
					goto Step_CheckSSCC;
				}
				else
				{
					titleKey = "MSG_TITLE_SCAN_NEXT_GS1_LABEL";

					allowedButtonsForLabelScreen = new List<string>();
					allowedButtonsForLabelScreen.Add("MSG_BUTTON_DONE");
					goto Step_ScanLabel;
				}

			}
			else if (msg.Name.EndsWith(".BackRequested"))
			{
				if ((currentLogUnit != null &&
				currentLogUnit.ItemsOnLogisticUnit.Count > 0))
				{
					//we want to go back, but we have some items in the list
					//ask user what to do
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"TitleKey", "MSG_TITLE_PRODUCTS_ON_LOGISTIC_UNIT_TO_RECEIVE",
							"MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE",
							"AllowToGoBack", true,
							"ButtonKeyYes", "MSG_BUTTON_BOOK_RECEIPT",
							"ButtonKeyNo", "MSG_BUTTON_CANCEL_RECEIPT"));
					msg = WaitForMessage();

					if (msg.Name.EndsWith(".Yes"))
					{
						if (currentLogUnit.ItemsOnLogisticUnit.Count > 0)
						{
							receiveAfterLocationScan = true;
							goto Step_EnterDestinationLocation;
						}
						//receive the items
						goto Step_ReceiveItems;
					}
					else if (msg.Name.EndsWith(".No"))
					{
						//Do nothing
					}
					else
					{
						//Go back
						goBack = true;
						goto Step_SelectOrder;
					}
				}

				if ((purchaseDeliveryNoteList != null &&
					purchaseDeliveryNoteList.Count > 0))
				{
					//we want to go back, but we have some items in the list
					//ask user what to do
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"TitleKey", "MSG_TITLE_PRODUCTS_ON_LIST_TO_RECEIVE",
							"MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE",
							"AllowToGoBack", true,
							"ButtonKeyYes", "MSG_BUTTON_BOOK_RECEIPT",
							"ButtonKeyNo", "MSG_BUTTON_CANCEL_RECEIPT"
							));
					msg = WaitForMessage();

					if (msg.Name.EndsWith(".Yes"))
					{
						//there are pallets received, but user wants to go back, so we will receive them right now
						goBack = true;

						// Inform the user items are receiving
						session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
							DefaultCultureInfo.Get(), BuildParamCollection(
								"MessageKey", "MSG_RECEIVING_ALL_ITEMS",
								"NoTranslationOfMessageKey", false,
								"ShowButton", false));

						goto Step_ReceiveItems;
					}
					else if (msg.Name.EndsWith(".No"))
					{
						//Do nothing
					}
					else
					{
						//Go back
						goBack = true;
						goto Step_SelectOrder;
					}
				}



				goBack = true;

				goto Step_SelectOrder;

			}
			else if (msg.Name.EndsWith(".ButtonClicked"))
			{
				//get buttonkey
				string btnKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

				goto Step_CheckSSCC;
			}

			initialErrorKey = "MSG_ERROR_OPERATION_NOT_SUPPORTED";
			goto Step_ScanLabel;


			#endregion

			Step_CheckSSCC:

			#region CHECK SSCC

			string SSCC = null;
			string scannedSSCC = null;
			int? luid = null;

			if (barcode != null &&
				barcode.GS1DataObject != null &&
				!string.IsNullOrEmpty(barcode.GS1DataObject.Sscc))
			{
				scannedSSCC = barcode.GS1DataObject.Sscc;

				//check if the scanned SSCC is valid
				if (!barcode.GS1DataObject.ValidateSSCC || sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteIsSSCCValid), scannedSSCC))
				{
					SSCC = scannedSSCC;
					int tempLUID = sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecuteGetLUIDBySSCC), SSCC);
					if (tempLUID > 0)
					{
						luid = tempLUID;
					}
					else
					{
						//no luid, so check if scanned sscc already exists in the 'in memory' list
						foreach (LogisticUnitGoodsReceipt foundLUID in purchaseDeliveryNoteList)
						{
							if (foundLUID.SSCC == SSCC)
							{
								luid = foundLUID.LogisticUnitId;
								break;
							}
						}
					}

					if (!luid.HasValue)
					{
						//LUID has no value, so create the LUID from the SSCC
						ExecuteMethodWithDbConnection<object>(out pmxError, sboProviderService, false, false,
						 delegate (PmxDbConnection conn, object[] parameters)
						 {
							 PmxLogisticUnitIDProvider luidProvider = new PmxLogisticUnitIDProvider(conn);
							 luid = luidProvider.GetCreateLUID(SSCC, null);
							 return null;
						 });
					}

				}
				else
				{
					//invalid
					initialErrorKey = "MSG_ERROR_INVALID_SSCC";
					goto Step_StartReceiving;
				}
			}

			if (luid.HasValue)
			{
				targetSSCC = SSCC;
				targetLuid = luid;
			}

			goto Step_IdentifyProduct;


			#endregion

			Step_IdentifyProduct:

            #region IDENTIFY PRODUCT

            receiveAfterLocationScan = false;

            if (currentLogUnit.ItemsOnLogisticUnit.Count == 0)
            {

                customerCode = null;
                customerAddress = null;
            }

            itemCode = null;
            itemDescription = null;
            itemInfo = null;
            numberOfItemsInPurchaseUnit = null;
            purchaseUom = null;
            gtin = null;
            purchaseOrderLineNum = null;
            bestBeforeDate = null;
            batchNumber = null;
            secondBatchNumber = null;

            query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, null, customerCode, customerAddress, whsInfo.SboWarehouseCode, sboProviderService.GetDbTool());
            dsItems = sboProviderService.RunView(true, null, null, query);

            RemoveReceivedItems(purchaseDeliveryNoteList, dsItems, currentLogUnit);


            if (this.GetNumberOfRows(dsItems) == 0 && currentLogUnit.ItemsOnLogisticUnit.Count == 0 && purchaseDeliveryNoteList.Count == 0)
            {
                //product not found
                initialErrorKey = "MSG_ERROR_INCORRECT_PRODUCT";
                goto Step_SelectOrder;
            }


            if (this.GetNumberOfRows(dsItems) == 0 &&
                purchaseDeliveryNoteList.Count > 0 &&
                currentLogUnit.ItemsOnLogisticUnit.Count == 0)
            {
                //no more items to receive, and we have already recorded items to be received, so go to step to book the goods receipt
                goto Step_ReceiveItems;
            }

            if (this.GetNumberOfRows(dsItems) == 1 &&
                !goBack)
            {

                itemCode = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                itemDescription = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;
                purchaseOrderLineNum = Convert.ToInt32(dsItems.Tables[0].Rows[0][ProductDataSet.Columns.LINE_NUMBER.Name]);
                salesOrderLineNum = Convert.ToInt32(dsItems.Tables[0].Rows[0]["S_" + PmxSalesOrderLineTable.Columns.LineNum.NAME]);
                salesOrderDocEntry = Convert.ToInt32(dsItems.Tables[0].Rows[0]["S_" + PmxSalesOrderLineTable.Columns.DocEntry.NAME]);
                stillToReceiveQuantity = Convert.ToDouble(dsItems.Tables[0].Rows[0][PmxPurchaseOrderLineTable.Columns.OpenInvQty.NAME]);

                numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItems.Tables[0]
                    .Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'")
                    [0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                purchaseUom = Convert.ToString(dsItems.Tables[0]
                    .Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'")
                    [0][SboPurchaseOrderLineTable.Columns.UomCode.NAME]);

                goto Step_GetItemInfo;
            }

            buttonList = new List<string>();

            buttonList.Add("MSG_BUTTON_SELECT_PRODUCT");



            //TODO: If we have items to be received in the in memory list, show button to perform the receipt
            if (currentLogUnit.ItemsOnLogisticUnit.Count > 0 || purchaseDeliveryNoteList.Count > 0)
            {
                //    //we have data in lists
                buttonList.Add("MSG_BUTTON_RECEIVE_ITEMS");
            }


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_IDENTIFY_PRODUCT",
                    "BarcodeController", barcodeController,
                    "AllowedButtons", buttonList.Count > 0 ? buttonList.ToArray() : null,
                    "ImageType", GS1ImageType.BoxImage
                    ));
            msg = WaitForMessage();
            goBack = false;
            //clear data
            initialErrorKey = null;
            //We need to keep old barcode scanned on logistic unit screen
            //barcode = null;
            gtin = null;
            itemInfo = null;
            if (msg.Name.EndsWith(".DataEntered"))
            {
                BarcodeContainer tempBarcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                //check if there is a product present
                if (tempBarcode != null &&
                (!string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(tempBarcode)) || !string.IsNullOrEmpty(tempBarcode.ItemCode)))
                {

                    gtin = BarcodeHelper.GetProductIdentification(tempBarcode);

                    query = BuildQuery.GetCodeNameItemsOrderByName(null, gtin, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, tempBarcode.ItemCode, customerCode, customerAddress, whsInfo.SboWarehouseCode, sboProviderService.GetDbTool());
                    DataSet dsTempItems = sboProviderService.RunView(true, null, null, query);



                    if (GetNumberOfRows(dsTempItems) > 0)
                    {

                        if (GetNumberOfRows(dsTempItems) == 1)
                        {

                            //copy the data
                            itemCode = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                            itemDescription = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;
                            purchaseOrderLineNum = Convert.ToInt32(dsItems.Tables[0].Rows[0][ProductDataSet.Columns.LINE_NUMBER.Name]);
                            salesOrderLineNum = Convert.ToInt32(dsItems.Tables[0].Rows[0]["S_" + PmxSalesOrderLineTable.Columns.LineNum.NAME]);
                            salesOrderDocEntry = Convert.ToInt32(dsItems.Tables[0].Rows[0]["S_" + PmxSalesOrderLineTable.Columns.DocEntry.NAME]);
                            stillToReceiveQuantity = Convert.ToDouble(dsItems.Tables[0].Rows[0][PmxPurchaseOrderLineTable.Columns.OpenInvQty.NAME]);                            


                            numberOfItemsInPurchaseUnit = Convert.ToDouble(dsTempItems.Tables[0]
                                .Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'")
                                [0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                            purchaseUom = Convert.ToString(dsTempItems.Tables[0]
                                .Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'")
                                [0][SboPurchaseOrderLineTable.Columns.UomCode.NAME]);


                            goto Step_GetItemInfo;
                        }
                        else
                        {
                            if (!string.IsNullOrEmpty(tempBarcode.ItemCode))
                            {
                                DataSet dsTempItem = dsItems.Clone();
                                DataRow[] itemRows = dsItems.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + tempBarcode.ItemCode + "'");
                                foreach (DataRow row in itemRows)
                                {
                                    dsTempItem.Tables[0].ImportRow(row);
                                }
                                dsItems = dsTempItem;
                            }
                            else
                            {
                                dsItems = dsTempItems;
                            }

                            goto Step_SelectProduct;
                        }

                    }
                    else
                    {
                        //reset data
                        initialErrorKey = "MSG_ERROR_PRODUCT_NOT_FOUND";
                        goto Step_IdentifyProduct;
                    }

                }
                else
                {
                    //reset data
                    initialErrorKey = "MSG_ERROR_NO_PRODUCT_ON_BARCODE";
                    goto Step_IdentifyProduct;
                }

            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                string tempButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (tempButtonKey == "MSG_BUTTON_SELECT_PRODUCT")
                {
                    goto Step_SelectProduct;
                }
                else
                {
                    //receive items
                    // Inform the user items are receiving
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_RECEIVING_ALL_ITEMS",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", false));
                    if (currentLogUnit.ItemsOnLogisticUnit.Count >  0 ) {
                        receiveAfterLocationScan = true;
                        goto Step_EnterDestinationLocation;
                    }

                    goto Step_ReceiveItems;
                }
            }

			//go back
			goto Step_StartReceiving;

        #endregion

        Step_SelectProduct:

            #region SELECT PRODUCT


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectPOLineScreen),
           DefaultCultureInfo.Get(), BuildParamCollection(
               "InitialErrorKey", initialErrorKey,
               "TitleKey", "MSG_TITLE_SELECT_PRODUCT",
               "POLineDS", dsItems
               ));
            msg = WaitForMessage();
            //clear data
            initialErrorKey = null;
            goBack = false;

            if (msg.Name.EndsWith(".POLineSelected"))
            {
                purchaseOrderLineNum = ExtractParameter<int?>(msg.Parameters, "LineNr");

                DataRow[] rows = dsItems.Tables[0].Select(string.Format("{0} = '{1}'", ProductDataSet.Columns.LINE_NUMBER.Name, purchaseOrderLineNum ?? -1));

                if (rows.Length > 0)
                {
                    itemCode = rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                    itemDescription = rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

                    salesOrderLineNum = Convert.ToInt32(rows[0]["S_" + PmxSalesOrderLineTable.Columns.LineNum.NAME]);
                    salesOrderDocEntry = Convert.ToInt32(rows[0]["S_" + PmxSalesOrderLineTable.Columns.DocEntry.NAME]);
                    stillToReceiveQuantity = Convert.ToDouble(rows[0][PmxPurchaseOrderLineTable.Columns.OpenInvQty.NAME]);

                    numberOfItemsInPurchaseUnit = Convert.ToDouble(rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                    purchaseUom = Convert.ToString(rows[0][SboPurchaseOrderLineTable.Columns.UomCode.NAME]);
                }

                goto Step_GetItemInfo;
            }

            goBack = true;
            goto Step_IdentifyProduct;




        #endregion

        Step_GetItemInfo:

            #region GET ITEM INFO

            if (itemInfo == null)
            {
                itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);
            }


            if (!numberOfItemsInPurchaseUnit.HasValue)
            {
                //take default 
                numberOfItemsInPurchaseUnit = itemInfo.NumberOfItemsPerPurchaseUnit;
                purchaseUom = itemInfo.PurchaseUom;
            }

            goto Step_SelectCustomerAddress;

        #endregion

        Step_SelectCustomerAddress:

            #region SELECT CUSTOMER ADDRESS

            if (string.IsNullOrEmpty(customerCode))
            {
                //No customer selected yet, so let the user select a customer/address
                query = BuildQuery.GetCustomersForPurchaseOrder(purchaseDocRef, purchaseOrderLineNum ?? -1, sboProviderService.GetDbTool());
                dsCustomers = sboProviderService.RunView(false, null, null, query);

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectCustomerAddressScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_SELECT_CUSTOMER_ADDRESS",
                        "CustomerAddressDS", dsCustomers
                        ));
                msg = WaitForMessage();

                initialErrorKey = null;
                if (msg.Name.EndsWith(".CustomerAddressSelected"))
                {
                    customerCode = ExtractParameter<string>(msg.Parameters, "customerCode");
                    customerName = ExtractParameter<string>(msg.Parameters, "customerName");
                    customerAddress = ExtractParameter<string>(msg.Parameters, "address");
                    goto Step_SelectLogisticUnit;
                }
                if (msg.Name.EndsWith(".RefreshRequested"))
                {
                    goto Step_SelectCustomerAddress;
                }
                //Go back
                goBack = true;
                goto Step_IdentifyProduct;
            }
			#endregion


			Step_SelectLogisticUnit:

			#region SELECT LOGISTIC UNIT

			if (targetLuid.HasValue)
			{
				//SSCC was scanned, so we can skip these steps
				goto Step_SelectBatchNumber;
			}

            int? tempLuid = null;
            string targetLogCarrierCode = null;
            targetStorLocCode = null;



            query = BuildQuery.GetLogisticUnitsForCustomer(customerCode, customerAddress, null, null, whsInfo.PmxWarehouseCode, null);

            DataSet dsLogisticUnitsForCustomer = sboProviderService.RunView(false, null, null, query);

            if (GetNumberOfRows(dsLogisticUnitsForCustomer) > 0)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Picking.ISelectLogisticCarrierScreen),
                    this.DefaultCultureInfo, BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_CUSTOMER_PALLET",
                    "BarcodeController", barcodeController,
                    "LogisticCarrierDS", dsLogisticUnitsForCustomer,
                    "ButtonKey", "MSG_BUTTON_NEW_LOGISTIC_UNIT"));
                msg = WaitForMessage();
                initialErrorKey = null;

                if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.Picking.ISelectLogisticCarrierScreenReply.LogisticCarrierSelected")
                {
                    tempLuid = ExtractParameter<int>(msg.Parameters, "luid");
                    targetSSCC = ExtractParameter<string>(msg.Parameters, "sscc");
                    int? tempMasterLuid = ExtractParameter<int?>(msg.Parameters, "masterLuid");

                    DataRow[] rows = dsLogisticUnitsForCustomer.Tables[0].Select(LogisticCarrierDataSet.Columns.LUID.Name + " = " + tempLuid.ToString());
                    if (rows.Length > 0)
                    {
                        targetStorLocCode = rows[0][LogisticCarrierDataSet.Columns.STORAGE_LOCATION_CODE.Name] as string;
                    }


                    targetLuid = tempLuid;
                   // targetLogCarrierCanBeFull = true;

                    sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null, delegate (PmxDbConnection dbConn, object[] parameters)
                    {
                        DbCommand dbCmd = dbConn.CreateCommand(BuildQuery.SetLogUnitReadyForShipping(tempLuid.Value, false, dbConn.DbTool));

                        dbCmd.ExecuteNonQuery();

                        return null;
                    });

                    goto Step_SelectBatchNumber;
                }
                else if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.Picking.ISelectLogisticCarrierScreenReply.ButtonClicked")
                {
                    // Continue with code below if-else's
                    tempLuid = null;
                }
                else if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.Picking.ISelectLogisticCarrierScreenReply.BackRequested")
                {
                    goto Step_IdentifyProduct;
                }
                else if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.Picking.ISelectLogisticCarrierScreenReply.StopRequested")
                {
                    return;
                }


                if (!tempLuid.HasValue) {

                    query = BuildQuery.GetLogisticCarriersOrderByName(true, true, sboProviderService.GetDbTool());
                    dsLogisticUnitsForCustomer = sboProviderService.RunView(false, null, null, query);

                    if (GetNumberOfRows(dsLogisticUnitsForCustomer) > 0)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreen),
                            this.DefaultCultureInfo, BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "TitleKey", "MSG_TITLE_SELECT_LOGISTIC_CARRIER",
                            "ProductDS", dsLogisticUnitsForCustomer,
                            "ButtonKey", "MSG_BUTTON_NO_LOGISTIC_CARRIER",
                            "AllowNoSelection", true));
                        msg = WaitForMessage();
                        initialErrorKey = null;

                        if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreenReply.ProductSelected")
                        {
                            targetLogCarrierCode = ExtractParameter<string>(msg.Parameters, "itemCode");
                        }
                        else if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreenReply.BackRequested")
                        {
                            goto Step_SelectLogisticUnit;
                        }
                        else if (msg.Name.EndsWith(".ButtonClicked"))
                        {
                            targetLogCarrierCode = null;
                        }
                        else if (msg.Name == "Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreenReply.StopRequested")
                        {
                            return;
                        }

                    }
                }
            }

        #endregion


        Step_SelectBatchNumber:

            #region SELECT BATCH NUMBER
            {
                GeneratedBatchNumberReception generatedBatch1Info = null;

                string tempBatchNumber = null;
                //     BarcodeContainer barcode = null;

                batchNumber = null;

                if (itemInfo.HasBatchnumber)
                {

                    generatedBatch1Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseDocRef, null, itemCode, cardCode, true);

                    tempBatchNumber = null;

                    ////If the batchnumber can be overwritten by GS1 batchnumber and it is filled in then
                    ////we use this batchnumber
                    //if (generatedBatch1Info.CanBeOverwrittenByGS1BatchNumber && (tempBatchNumber != null) && (tempBatchNumber.Length > 0))
                    //{
                    //    if (goBack)
                    //    {
                    //        goto Step_IdentifyProduct;
                    //    }
                    //    //user cannot change batchnumber
                    //    batchNumber = tempBatchNumber;
                    //    goto Step_SecondBatchNumber;
                    //}
                    //else
                    //{
                    tempBatchNumber = generatedBatch1Info.BatchNumber;

                    if (generatedBatch1Info.IsUserAllowedToChange || string.IsNullOrEmpty(generatedBatch1Info.BatchNumber))
                    {
                        DataSet dsBatchToSelect = null;

                        if (allowToSelectBatch)
                        {
                            query = BuildQuery.GetAllBatchesInStock(itemInfo.ItemCode);
                            dsBatchToSelect = sboProviderService.RunView(true, null, null, query);
                        }


                        //no batchnumber provided, so ask for batchnumber
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER",
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                             "CurrentSSCC", targetSSCC,
                             "InitialBatchNumber", tempBatchNumber,
                             "AllowToSelect", (this.GetNumberOfRows(dsBatchToSelect) > 0 && allowToSelectBatch),
                             "BatchDS", dsBatchToSelect,
                             //"Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom
                             "Uom", itemInfo.InventoryUom
                            ));

                        msg = WaitForMessage();
                        goBack = false;
                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".BatchNumberEntered"))
                        {
                            batchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");

                            goto Step_SecondBatchNumber;
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {

                            goBack = true;
                            goto Step_IdentifyProduct;
                        }

                    }
                    else
                    {
                        if (goBack)
                        {
                            goto Step_IdentifyProduct;
                        }
                        batchNumber = tempBatchNumber;
                    }

                    goBack = false;

                    goto Step_SecondBatchNumber;

                }
                else
                {
                    //no batchnumber, so we try to get second batch number
                    goto Step_SecondBatchNumber;
                }
            }
        #endregion

        Step_SecondBatchNumber:

            #region ENTER SECOND BATCH NUMBER

            GeneratedBatchNumberReception generatedBatch2Info = null;

            secondBatchNumber = null;

            if (itemInfo.HasSecondBatchNumber)
            {
                generatedBatch2Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseDocRef, null, itemCode, cardCode, false);

                string tempBatchNumber = null;

                tempBatchNumber = generatedBatch2Info.BatchNumber;

                DataSet dsInternalBatchToSelect = null;

                if (allowToSelectBatch)
                {
                    query = BuildQuery.GetAllInternalBatchesInStock(itemInfo.ItemCode, batchNumber);
                    dsInternalBatchToSelect = sboProviderService.RunView(true, null, null, query);
                    if (this.GetNumberOfRows(dsInternalBatchToSelect) == 1)
                    {
                        tempBatchNumber = dsInternalBatchToSelect.Tables[0].Rows[0][TextDataSet.Columns.TEXT.Name] as string;
                    }

                }


                if (generatedBatch2Info.IsUserAllowedToChange || string.IsNullOrEmpty(generatedBatch2Info.BatchNumber))
                {
                    //no batchnumber provided, so ask for batchnumber
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                     DefaultCultureInfo.Get(), BuildParamCollection(
                         "InitialErrorKey", initialErrorKey,
                         "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER2",
                         "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                         "ItemDescription", itemDescription,
                         "ItemCode", itemInfo.ItemCode,
                         "ItemBarcode", itemInfo.CodeBars,
                         "StillToReceive", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                         "CurrentSSCC", targetSSCC,
                         //"Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                         "Uom", itemInfo.InventoryUom,
                         "AllowToSelect", (this.GetNumberOfRows(dsInternalBatchToSelect) > 0),
                         "BatchDS", dsInternalBatchToSelect,
                         "InitialBatchNumber", tempBatchNumber
                        ));
                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;
                    goBack = false;

                    if (msg.Name.EndsWith(".BatchNumberEntered"))
                    {
                        secondBatchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");
                        goto Step_BestBeforeDate;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        if (itemInfo.HasBatchnumber)
                        {
                            goto Step_SelectBatchNumber;
                        }
                        else
                        {
                            goto Step_IdentifyProduct;
                        }
                    }

                }

                goto Step_BestBeforeDate;
            }
        #endregion

        Step_BestBeforeDate:

            #region PROVIDE BEST BEFORE DATE

            if (itemInfo.HasBestBeforeDate)
            {

                if (goBack)
                {
                    if (itemInfo.HasSecondBatchNumber)
                    {
                        goto Step_SecondBatchNumber;
                    }
                    else if (itemInfo.HasBatchnumber)
                    {
                        goto Step_SelectBatchNumber;
                    }

                    goto Step_IdentifyProduct;

                }

                generatedBBDInfo = sboProviderService.InvokeMethodWithDbConnection<GeneratedBestBeforeDateReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBestBeforeDateReception>(ExecuteGenerateBBDForReception), itemCode);

                bestBeforeDate = generatedBBDInfo.GeneratedDateTime.Value;
                bool allowToChangeGeneratedBBDOnReception = generatedBBDInfo.CanUserChangeGeneratedBBD;

                if (allowToChangeGeneratedBBDOnReception)
                {
                    bool allowToCalculateBasedOnManufacturingDate = sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfAllowToCalculateBasedOnManufacturingDate));

                    goBack = false;

                    //ask for best before date
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IEnterBestBeforeDateScreen),
                     DefaultCultureInfo.Get(), BuildParamCollection(
                         "InitialErrorKey", initialErrorKey,
                         "TitleKey", "MSG_TITLE_ENTER_BEST_BEFORE_DATE",
                         "DefaultDateTime", bestBeforeDate,
                         "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                         "ItemDescription", itemDescription,
                         "ItemCode", itemInfo.ItemCode,
                         "ItemBarcode", itemInfo.CodeBars,
                         "StillToReceive", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                         "CurrentSSCC", targetSSCC,
                         //"Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                         "Uom", itemInfo.InventoryUom,
                         "BatchNumber", batchNumber
                         ));
                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".BestBeforDateEntered"))
                    {
                        bestBeforeDate = ExtractParameter<DateTime?>(msg.Parameters, "bestBeforeDate");
                        goto Step_EnterQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        goto Step_SecondBatchNumber;
                    }
                }

                goto Step_EnterPackagingQuantity;
            }

        #endregion

        Step_EnterPackagingQuantity:

            #region ENTER PACKAGING QUANTITY

            if ((itemInfo.HasBatchnumber || itemInfo.HasSecondBatchNumber || itemInfo.HasBestBeforeDate))
            {

                currentListOfTransactionalPackagingTypeInfos = GetTransactionalPackagingInfo(purchaseDeliveryNoteList, batchNumber, secondBatchNumber, bestBeforeDate, itemCode);

                if (currentListOfTransactionalPackagingTypeInfos == null)
                {
                    query = BuildQuery.GetExistingITRI(itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                    DataSet dsExistingBatch = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(dsExistingBatch) == 0)
                    {
                        //batch not found, so we need to enter the quantity for the packaging types
                        currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);
                        bool foundAtLeastOnePackagingTypeToShowOnScreen = false;
                        bool isFirst = true;
                        listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();
                        foreach (PmxItemPackagingTypeInfo packType in itemInfo.ListOfPackagingTypes)
                        {

                            PackagingTypeInfo info = new PackagingTypeInfo();

                            if (isFirst)
                            {
                                //info.NumberOfDecimals = itemInfo.UomDecimals;
                            }

                            info.Quantity = packType.Quantity;
                            info.PackagingTypeCode = packType.PackagingTypeCode;
                            info.PackagingTypeName = packType.PackagingTypeName;

                            info.ShowOnScreen = (packType.AskDuringReception &&
                            (!packType.Barcodes.Contains(gtin)));

                            listOfPackagingTypeInfosForScreen.Add(info);

                            if (!foundAtLeastOnePackagingTypeToShowOnScreen &&
                                info.ShowOnScreen)
                            {
                                foundAtLeastOnePackagingTypeToShowOnScreen = true;
                            }

                            isFirst = false;
                        }

                        if (foundAtLeastOnePackagingTypeToShowOnScreen)
                        {
                            initialErrorKey = "MSG_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES";
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "TitleKey", "MSG_TITLE_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES",
                                "BarcodeController", barcodeController,
                                "ItemDescription", itemDescription,
                                "ItemCode", itemInfo.ItemCode,
                                "ItemBarcode", itemInfo.CodeBars,
                                "UOM", itemInfo.InventoryUom,
                                "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                "IsForEnteringDefaultPackagingQuantity", true,
                                "BatchNumber", batchNumber,
                                "BestBeforeDate", bestBeforeDate,
                                "SSCC", targetSSCC,
                                "DocNum", Convert.ToString(purchaseOrderDocNum),
                                "InitialErrorKeyIsError", false
                                ));

                            msg = WaitForMessage();
                            goBack = false;
                            // reset error
                            initialErrorKey = null;

                            if (msg.Name.EndsWith(".QuantitiesEntered"))
                            {
                                PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                                //build the list of packaging quantities
                                foreach (ItemTransactionalPackagingTypeInfo info in currentListOfTransactionalPackagingTypeInfos)
                                {
                                    //try to get new qty from user
                                    if (screenListOfPackagingTypeInfos.PackagingTypeInfoList.ContainsKey(info.PackagingTypeCode))
                                    {
                                        info.Quantity = screenListOfPackagingTypeInfos.PackagingTypeInfoList[info.PackagingTypeCode].Quantity;
                                    }
                                }

                                goto Step_EnterQuantity;
                            }
                            else if (msg.Name.EndsWith(".BackRequested"))
                            {
                                goBack = true;
                                if (itemInfo.HasBestBeforeDate)
                                {
                                    goto Step_BestBeforeDate;
                                }
                                else if (itemInfo.HasSecondBatchNumber)
                                {
                                    goto Step_SecondBatchNumber;
                                }
                                goto Step_SelectBatchNumber;
                            }

                        }

                    }
                    else
                    {
                        //we found the batch, so now fill in the packaging data from the batch
                        currentListOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();
                        foreach (DataRow row in dsExistingBatch.Tables[0].Rows)
                        {
                            ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                            newPackInfo.PackagingTypeCode = Convert.ToString(row[PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME]);
                            newPackInfo.Quantity = Convert.ToDouble(row[PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME]);
                            newPackInfo.ItriKey = Convert.ToInt32(row[PmxItemTransactionalInfoTable.Columns.InternalKey.NAME]);

                            newPackInfo.ItemCode = itemInfo.ItemCode;

                            currentListOfTransactionalPackagingTypeInfos.Add(newPackInfo);
                        }

                        goto Step_EnterQuantity;
                    }
                }

                goto Step_EnterQuantity;
            }
            else
            {
                //no batch info
                //get the packaging types qty from item
                currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);



                goto Step_EnterQuantity;
            }

        #endregion

        Step_EnterQuantity:

            #region ENTER QUANTITY

            quantity = 0;
            quantityUom2 = null;
            listOfSerialNumbers = null;
            m_subFlowListOfSerialNumbers = null;
            askForPieces = false;
            askForWeight = false;


            initialQuantity = itemInfo.DefaultQuantityOnLogisticUnit > 0 ? itemInfo.DefaultQuantityOnLogisticUnit : 1;
            
            double maxQuantity = -1;

            if (!allowToExceedOrderedQuantity)
            {
                maxQuantity = stillToReceiveQuantity;
            }
     

            bool getNormalQuantity = true;

            if ((itemInfo.HasSerialNumber || itemInfo.HasSAPSerialNumber))
            {
                #region SERIAL NUMBER


                getNormalQuantity = false;

                //show screen to ask user what to do.
                List<string> buttonKeys = new List<string>(new Collection<string>() { "MSG_BUTTON_SERIAL_NUMBER", "MSG_BUTTON_SERIAL_NUMBER_RANGE" });

                if (!(//itemInfo.TrackLocationSerialNumber ||
                    (itemInfo.HasSAPSerialNumber && itemInfo.ManageMethod == SboItemManageMethod.OnEveryTransaction)))
                {
                    buttonKeys.Add("MSG_BUTTON_NO_SERIAL_NUMBER");
                }

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY_SERIAL_NUMBER_TASK",
                        "AllowedButtons", buttonKeys.ToArray(),
                        "EnabledToolBarButtons", ToolBarButtons.Back
                        ));
                msg = WaitForMessage();
                goBack = false;
                initialErrorKey = null;
                if (msg.Name.EndsWith(".ButtonClicked"))
                {
                    string buttonKeySerial = ExtractParameter<string>(msg.Parameters, "buttonKey");

                    if (buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER" ||
                        buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER_RANGE")
                    {
                        #region ENTER SERIAL NUMBERS

                        //get ITRI
                        int? itriKey = null;
                        if (itemInfo.HasBestBeforeDate ||
                            itemInfo.HasSecondBatchNumber ||
                            itemInfo.HasBatchnumber)
                        {
                            itriKey = sboProviderService.InvokeMethodWithDbConnection<int?>(false, false, null, null, new DelegateWithPmxDbConnection<int?>(ExecuteGetCreateItemTransactionalInfoKey), itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                        }

                        goBack = false;
                        bool isSerialNumberRange = (buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER_RANGE");

                        m_enterQuantitySubFlow.BindParameters(
                            this.DefaultCultureInfo,
                            this.PmxOseCompany,
                            new ReadOnlyBinder<string>("TitleKey", "MSG_TITLE_ENTER_QUANTITY"),
                            new ReadOnlyBinder<PmxItemInfo>("ItemInfo", itemInfo),
                            new ReadOnlyBinder<string>("BatchNumber", batchNumber),
                            new ReadOnlyBinder<DateTime?>("BestBeforeDate", bestBeforeDate),
                            new ReadOnlyBinder<int?>("ItriKey", itriKey),
                            new ReadOnlyBinder<string>("LocationCode", dockCode),
                            new ReadOnlyBinder<string>("SSCC", targetSSCC),

                            new ReadOnlyBinder<string>("DocNum", Convert.ToString(purchaseOrderDocNum)),
                            new ReadOnlyBinder<bool>("UsePickingInfo", false),

                            new ReadOnlyBinder<bool>("AllowZero", false),
                            new ReadOnlyBinder<double>("InitialQuantity", initialQuantity),
                            new ReadOnlyBinder<string>("MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"),
                            new ReadOnlyBinder<double>("StillToQuantity", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals)),
                            new ReadOnlyBinder<double>("MaximumQuantity", maxQuantity),
                            new ReadOnlyBinder<double>("TotalQuantityToPick", 0),
                            new ReadOnlyBinder<string>("UOM", itemInfo.InventoryUom),
                            new ReadOnlyBinder<int>("NumberOfDigitsAfterDecimal", (itemInfo != null) ? itemInfo.UomDecimals : 0),

                            new ReadOnlyBinder<double>("InnerQuantity", 1),
                            new ReadOnlyBinder<string>("InnerUOM", null),
                            new ReadOnlyBinder<bool>("ForceInputSerialNumbers", true),
                            new ReadOnlyBinder<string>("ObjectType", ((int)SboLinkDocumentType.PurchaseOrder).ToString()),
                            new ReadOnlyBinder<int?>("DocEntry", purchaseOrderDocNum),
                            new ReadOnlyBinder<bool>("UseSerialNumberRange", isSerialNumberRange),

                            new ReadOnlyBinder<int?>("LUID", null),


                            new ReadWriteBinder<double>("QuantityEntered", this, "m_subFlowQuantity"),
                            new ReadWriteBinder<bool>("BackRequested", this, "m_subFlowBackRequested"),
                            new ReadWriteBinder<Collection<string>>("ListOfSerialNumbers", this, "m_subFlowListOfSerialNumbers")

                            );
                        m_subFlowBackRequested = false;
                        this.StartSubFlowAndWait(m_enterQuantitySubFlow, true);

                        if (m_subFlowBackRequested)
                        {
                            goto Step_EnterQuantity;
                        }

                        listOfSerialNumbers = m_subFlowListOfSerialNumbers;

                        quantity = m_subFlowQuantity / (numberOfItemsInPurchaseUnit ?? 1);

                        goto Step_CheckQuantity;

                        #endregion

                    }

                    getNormalQuantity = true;
                }

                if (msg.Name.EndsWith(".BackRequested"))
                {
                    goBack = true;
                    goto Step_GoBackOnEnterQuantity;
                }



                #endregion
            }

            if (itemInfo.ListOfPackagingTypes != null &&
                currentListOfTransactionalPackagingTypeInfos.Count > 0)
            {
                #region GET QUANTITY WITH PACKAGING TYPE

                //build list of packaging types

                listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();

                //add first one for the uom

                PackagingTypeInfo info = new PackagingTypeInfo();

                info.Quantity = 1;
                info.PackagingTypeCode = null;
                info.PackagingTypeName = itemInfo.InventoryUom == null ? itemInfo.ItemCode : itemInfo.InventoryUom;
                info.QuantityPerPack = 1;
                if (!string.IsNullOrEmpty(itemInfo.CodeBars))
                {
                    info.Barcode.Add(itemInfo.CodeBars);
                }
                info.NumberOfDecimals = itemInfo.UomDecimals;
                if (info.Barcode.Contains(gtin))
                {
                    //We had a quantity scanned in barcode, so use that one 
                    info.InitialQuantity = initialQuantity;
                }
                else
                {
                    info.InitialQuantity = 0;
                }
                listOfPackagingTypeInfosForScreen.Add(info);


                foreach (ItemTransactionalPackagingTypeInfo packType in currentListOfTransactionalPackagingTypeInfos)
                {

                    info = new PackagingTypeInfo();

                    info.Quantity = packType.Quantity;
                    info.PackagingTypeCode = packType.PackagingTypeCode;
                    info.PackagingTypeName = GetPackTypeName(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                    info.Barcode = GetPackBarcode(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                    info.HideDuringEnteringQuantity = GetHideDuringEnteringQuantity(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);

                    if (info.Barcode.Contains(gtin))
                    {
                        info.InitialQuantity = 1;
                        //Check if barcode is also added to inventory uom.
                        //If so, we need to adjust initial qty
                        if (listOfPackagingTypeInfosForScreen[0].Barcode.Contains(gtin))
                        {
                            listOfPackagingTypeInfosForScreen[0].InitialQuantity = 0;
                        }
                    }
                    else
                    {
                        info.InitialQuantity = 0;
                    }

                    info.QuantityPerPack = packType.Quantity;

                    listOfPackagingTypeInfosForScreen.Add(info);
                }

                #endregion
            }

            if (itemInfo.IsCatchWeightItem)
            {
                #region CATCH WEIGHT

                getNormalQuantity = false;


                askForPieces = itemInfo.UomToUseForPurchase == PmxUomToUse.UOM1AndUOM2 ||
                                    itemInfo.UomToUseForPurchase == PmxUomToUse.UOM1;
                askForWeight = itemInfo.UomToUseForPurchase == PmxUomToUse.UOM1AndUOM2 ||
                                    itemInfo.UomToUseForPurchase == PmxUomToUse.UOM2;


                double? quantityForPieces = null;
                double? quantityForWeight = null;


                if (askForPieces)
                {

                    if (itemInfo.ListOfPackagingTypes != null &&
                        currentListOfTransactionalPackagingTypeInfos.Count > 0)
                    {
                        #region QUANTITY WITH PACKAGING TYPE

                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                            "BarcodeController", barcodeController,
                            "ItemDescription", itemDescription,
                            "ItemCode", itemInfo.ItemCode,
                            "ItemBarcode", itemInfo.CodeBars,
                            "UOM", itemInfo.InventoryUom,
                            "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                            "IsForEnteringDefaultPackagingQuantity", false,
                            "BatchNumber", batchNumber,
                            "BestBeforeDate", bestBeforeDate,
                            "SSCC", targetSSCC,
                            "DocNum", Convert.ToString(purchaseOrderDocNum),
                            "StillToQuantity", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                            "MaximumQuantity", Math.Round(maxQuantity, itemInfo.UomDecimals),
                            "MaximumUOM", itemInfo.InventoryUom,
                            "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE",
                            "AllowZero", false
                            ));

                        msg = WaitForMessage();

                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".QuantitiesEntered"))
                        {
                            PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                            quantityForPieces = 0;

                            //build the list of packaging quantities
                            foreach (PackagingTypeInfo infoForQty in screenListOfPackagingTypeInfos.PackagingTypeInfoList.Values)
                            {
                                quantityForPieces += (infoForQty.Quantity * infoForQty.QuantityPerPack);
                            }
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            goBack = true;
                            goto Step_GoBackOnEnterQuantity;
                        }
                        #endregion
                    }
                    else
                    {

                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                           DefaultCultureInfo.Get(), BuildParamCollection(
                           "InitialErrorKey", initialErrorKey,
                           "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                           "BarcodeController", barcodeController,
                           "ItemDescription", itemDescription,
                           "ItemCode", itemInfo.ItemCode,
                           "ItemBarcode", itemInfo.CodeBars,
                           "InitialQuantity", initialQuantity,
                           "InnerQuantity", 1,
                           "MaximumQuantity", maxQuantity,
                           "NumberOfDigitsAfterDecimal", itemInfo.UomDecimals,
                           "InnerUOM", itemInfo.InventoryUom,
                           "UOM", itemInfo.InventoryUom,
                           "BarcodesAndUomQuantities", itemInfo.PurchaseBarcodesAndUomQuantities,
                           "BatchNumber", batchNumber,
                           "BestBeforeDate", bestBeforeDate,
                           "SSCC", targetSSCC,
                           "DocNum", Convert.ToString(purchaseOrderDocNum),
                           "StillToQuantity", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                           "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"
                           ));

                        msg = WaitForMessage();
                        goBack = false;
                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".QuantityEntered"))
                        {
                            quantityForPieces = ExtractParameter<double>(msg.Parameters, "quantity");
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            goBack = true;
                            goto Step_GoBackOnEnterQuantity;
                        }
                    }
                }

                double totalInvQtyScanned = 0;

                if (askForWeight)
                {
                    quantityForWeight = 0;
                    double maxQuantityForWeight = -1;

                    if (quantityForPieces.HasValue)
                    {
                        //Calculate weight maximum
                        double? tempMax = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(quantityForPieces.Value, itemInfo);

                        if (itemInfo.CatchWeightWeightTolerancePercentage >= 100)
                        {
                            //Tolerance greater than 100%, so actually no maximum is required
                            maxQuantityForWeight = -1;
                        }
                        else
                        {
                            //Calculate weight maximum
                            if (tempMax.HasValue)
                            {
                                maxQuantityForWeight = tempMax.Value;
                            }
                        }
                    }
                    else
                    {
                        double? tempMax = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(stillToReceiveQuantity, itemInfo);

                        maxQuantityForWeight = maxQuantity == -1 ? -1 : tempMax.HasValue ? tempMax.Value : -1;
                    }

                    totalInvQtyScanned = 0;

                Step_NextWeight:

                    double? tempMaxToUse = null;

                    double calculatedQuantityPieces = 0;

                    if (itemInfo.CatchWeightScanWeightForEachCase)
                    {
                        //Scan each piece
                        calculatedQuantityPieces = itemInfo.CatchWeightQuantityInCase;

                        //It is possible that number of decimals is larger than 0, which means that it is not really pieces.
                        //So we need to check if the remaining quantity is lower than 1.
                        //If this is the case, we need to use this quantity!
                        if (itemInfo.UomDecimals > 0 &&
                            ((quantityForPieces.HasValue ? quantityForPieces.Value : stillToReceiveQuantity) - totalInvQtyScanned) < itemInfo.CatchWeightQuantityInCase)
                        {
                            calculatedQuantityPieces = (quantityForPieces.HasValue ? quantityForPieces.Value : stillToReceiveQuantity) - totalInvQtyScanned;
                        }

                        tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem(calculatedQuantityPieces, itemInfo);

                        if (totalInvQtyScanned == 0)
                        {
                            //This is the first time asking for weight, so allow to enter full quantity
                            tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem((quantityForPieces.HasValue ? quantityForPieces.Value : stillToReceiveQuantity) - totalInvQtyScanned, itemInfo);
                        }

                    }
                    else
                    {
                        tempMaxToUse = PmxItemAllConnectionsProvider.GetMaximumWeightForCatchWeightItem((quantityForPieces.HasValue ? quantityForPieces.Value : stillToReceiveQuantity) - totalInvQtyScanned, itemInfo);
                    }

                    double maxQuantityForWeightToUse = maxQuantityForWeight == -1 ? -1 : tempMaxToUse.HasValue ? tempMaxToUse.Value : -1;

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                   DefaultCultureInfo.Get(), BuildParamCollection(
                   "InitialErrorKey", initialErrorKey,
                   "TitleKey", "MSG_TITLE_ENTER_WEIGHT",
                   "BarcodeController", barcodeController,
                   "ItemDescription", itemDescription,
                   "ItemCode", itemInfo.ItemCode,
                   "ItemBarcode", itemInfo.CodeBars,
                   "BarcodesAndUomQuantities", itemInfo.PurchaseBarcodesAndUomQuantities,
                   "InitialQuantity", 0,
                   "InnerQuantity", 1,
                   "MaximumQuantity", maxQuantityForWeightToUse,
                   "NumberOfDigitsAfterDecimal", itemInfo.Uom2Decimals,
                   "InnerUOM", itemInfo.Uom2,
                   "UOM", itemInfo.Uom2,
                   "BatchNumber", batchNumber,
                   "BestBeforeDate", bestBeforeDate,
                   "SSCC", targetSSCC,
                   "DocNum", Convert.ToString(purchaseOrderDocNum),
                   "StillToQuantity", Math.Round((PmxItemAllConnectionsProvider.CalculateWeightFromPieces(stillToReceiveQuantity, itemInfo).Value / 1), itemInfo.Uom2Decimals),
                   "MessageKeyStillQuantity", "MSG_LBL_RECEIVING",
                   "ForceGS1_128", true,
                   "GS1WeightAI", itemInfo.Uom2GS1MeasureType,
                   "UomToDisplayOnQtyProvider", itemInfo.Uom2,
                   "QtyEntered", quantityForWeight.Value,
                   "AllowZero", true,
                   "InfoMessageKey", "MSG_LBL_NUMBER_OF_PIECES",
                   "InfoValue", quantityForPieces.HasValue ? string.Format("{0}/{1}", totalInvQtyScanned, quantityForPieces.Value) : totalInvQtyScanned.ToString()



                   ));

                    msg = WaitForMessage();
                    goBack = false;
                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        double tempWeight = ExtractParameter<double>(msg.Parameters, "quantity");
                        if (tempWeight != 0)
                        {
                            if (!quantityForWeight.HasValue)
                            {
                                quantityForWeight = 0;
                            }

                            double tempInvQty = 0;
                            if (itemInfo.CatchWeightScanWeightForEachCase)
                            {
                                //Regard each scan as the number of pieces in a case.
                                tempInvQty = calculatedQuantityPieces;

                                //Check if this is within tolerance. when it is the first time
                                if (totalInvQtyScanned == 0 &&
                                    !PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(tempInvQty, tempWeight, itemInfo) &&
                                    quantityForPieces.HasValue)
                                {
                                    //If not, check if it is within tolerance of total quantity
                                    if (PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, tempWeight, itemInfo))
                                    {
                                        //It is within tolerance, so regard this as a weight for the total quantity
                                        tempInvQty = quantityForPieces.Value;
                                    }
                                }



                            }
                            else
                            {
                                tempInvQty = PmxItemAllConnectionsProvider.CalculatePiecesFromWeight(tempWeight, itemInfo).Value;
                            }

                            if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(tempInvQty, tempWeight, itemInfo))
                            {
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                   this.DefaultCultureInfo, BuildParamCollection(
                                   "MessageKey", "MSG_ERROR_CW_WEIGHT_NOT_WITHIN_TOLERANCE",
                                   "ShowButton", true,
                                   "IsError", true,
                                   "Parameters", new object[] { tempWeight, tempInvQty, itemInfo.CatchWeightWeightTolerancePercentage }));
                                msg = WaitForMessage();

                                goto Step_NextWeight;
                            }

                            totalInvQtyScanned += tempInvQty;
                            quantityForWeight += tempWeight;

                            #region PRINT LABELS


                            //Print labels for catch weight here, because each label will have a different weight
                            try
                            {
                                numberOfItemLabels = 0;
                                if (itemInfo.PrintItemLabel)
                                {
                                    if (PmxOseCompany.Get().GoodsReceiptAutoPrintItemLabels)
                                    {
                                        if (askUserToPrintLabels)
                                        {
                                            //ask user if he wants to print item labels
                                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                                DefaultCultureInfo.Get(), BuildParamCollection(
                                                    "TitleKey", "MSG_TITLE_PRINT_ITEM_LABEL",
                                                    "MessageKey", "MSG_QUESTION_PRINT_ITEM_LABEL"));
                                            msg = WaitForMessage();

                                            if (msg.Name.EndsWith(".Yes"))
                                            {
                                                numberOfItemLabels = 1;
                                            }
                                        }
                                        else
                                        {
                                            //Print 1 label for the weight
                                            numberOfItemLabels = 1;
                                        }
                                    }
                                    else
                                    {
                                        //ask user if he wants to print item labels
                                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                            DefaultCultureInfo.Get(), BuildParamCollection(
                                                "TitleKey", "MSG_TITLE_PRINT_ITEM_LABEL",
                                                "MessageKey", "MSG_QUESTION_PRINT_ITEM_LABEL"));
                                        msg = WaitForMessage();

                                        if (msg.Name.EndsWith(".Yes"))
                                        {
                                            numberOfItemLabels = 1;
                                        }
                                    }

                                    if (numberOfItemLabels > 0)
                                    {
                                        // print the labels

                                        //Set the data into binders
                                        this.m_printItemLabelFlow_LocationCode = dockCode;
                                        this.m_printItemLabelFlow_NeededBatchNumber = batchNumber;
                                        this.m_printItemLabelFlow_NeededBatchNumber2 = secondBatchNumber;
                                        this.m_printItemLabelFlow_NeededBestBeforeDate = bestBeforeDate;
                                        this.m_printItemLabelFlow_NeededItemCode = itemInfo.ItemCode;
                                        this.m_printItemLabelFlow_NeededNrOfLabels = numberOfItemLabels;
                                        this.m_printItemLabelFlow_EnteredQuantity = quantityForPieces.HasValue ? quantityForPieces.Value : tempInvQty;
                                        this.m_printItemLabelFlow_EnteredQuantityUom2 = tempWeight;
                                        this.m_printItemLabelFlow_ShowPrintMessage = false;

                                        m_printItemLabelFlow_NeededPackagingType = null;
                                        m_printItemLabelFlow_NeededQuantityByPackagingType = null;

                                        if (numberOfItemLabels.HasValue)
                                        {
                                            this.m_printItemLabelFlow_NeededPackagingType = purchaseUom;

                                            if (numberOfItemsInPurchaseUnit.HasValue)
                                            {
                                                this.m_printItemLabelFlow_NeededQuantityByPackagingType = Convert.ToInt32(Math.Ceiling(numberOfItemsInPurchaseUnit.Value));
                                            }
                                        }



                                        //call flow
                                        base.StartSubFlowAndWait(m_printItemLabelFlow, true);
                                        goBack = false;
                                        if (m_printItemLabelFlow_BackRequested)
                                        {
                                            goBack = true;
                                            goto Step_GoBackOnEnterQuantity;
                                        }
                                    }


                                }
                            }
                            catch (Exception ex)
                            {
                                s_log.Error("", ex);
                                if (!(ex is ProdumexException) || ((ProdumexException)ex).Error == null)
                                {
                                    // Inform the user with the error
                                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                            "MessageKey", ExceptionHelper.Format(ExceptionHelper.Content.InnerExceptions, ex, DefaultCultureInfo.Get()),
                                            "NoTranslationOfMessageKey", true,
                                            "IsError", true,
                                            "ShowButton", true));
                                    WaitForMessage();

                                }
                                else
                                {
                                    // Inform the user with the error
                                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                            "PmxError", ((ProdumexException)ex).Error,
                                            "ShowButton", true));
                                    WaitForMessage();
                                }
                            }

                            #endregion

                            if (!quantityForPieces.HasValue ||
                                (quantityForPieces.HasValue && totalInvQtyScanned < quantityForPieces.Value))
                            {
                                //Pieces were asked, and the number of pieces was not reached yet, so ask next weight.
                                goto Step_NextWeight;
                            }
                        }
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        goto Step_GoBackOnEnterQuantity;
                    }
                }

                //Check if we need to calculate any of the quantities.

                if (!quantityForWeight.HasValue)
                {
                    quantityForWeight = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(quantityForPieces.Value, itemInfo);
                }
                else if (!quantityForPieces.HasValue)
                {
                    if (totalInvQtyScanned > 0)
                    {
                        quantityForPieces = totalInvQtyScanned;
                    }
                    else
                    {
                        quantityForPieces = PmxItemAllConnectionsProvider.CalculatePiecesFromWeight(quantityForWeight.Value, itemInfo);
                    }
                }


                //Check if quantity is within tolerance
                if (!PmxItemAllConnectionsProvider.IsCatchWeightWithinTolerance(quantityForPieces.Value, quantityForWeight.Value, itemInfo))
                {
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            this.DefaultCultureInfo, BuildParamCollection(
                            "MessageKey", "MSG_ERROR_CW_WEIGHT_NOT_WITHIN_TOLERANCE",
                            "ShowButton", true,
                            "IsError", true,
                            "Parameters", new object[] { quantityForWeight.Value, quantityForPieces.Value, itemInfo.CatchWeightWeightTolerancePercentage }));
                    msg = WaitForMessage();

                    goto Step_EnterQuantity;
                }

                //The quantity from screens is in inventory uom.
                //So we need to rework to quantity in purchase uom
                quantity = quantityForPieces.Value / numberOfItemsInPurchaseUnit.Value;
                quantityUom2 = quantityForWeight.Value;



                goto Step_CheckQuantity;

                #endregion
            }

            if (getNormalQuantity)
            {
                if (itemInfo.ListOfPackagingTypes != null &&
                    currentListOfTransactionalPackagingTypeInfos.Count > 0)
                {
                    #region QUANTITY WITH PACKAGING TYPE

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                        "InitialErrorKey", initialErrorKey,
                                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                                        "BarcodeController", barcodeController,
                                        "ItemDescription", itemDescription,
                                        "ItemCode", itemInfo.ItemCode,
                                        "ItemBarcode", itemInfo.CodeBars,
                                        //"UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                                        "UOM", itemInfo.InventoryUom,
                                        "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                        "IsForEnteringDefaultPackagingQuantity", false,
                                        "BatchNumber", batchNumber,
                                        "BestBeforeDate", bestBeforeDate,
                                        "SSCC", targetSSCC,
                                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                                        "StillToQuantity", Math.Round(stillToReceiveQuantity, itemInfo.UomDecimals),
                                        "MaximumQuantity", Math.Round(maxQuantity, itemInfo.UomDecimals),
                                        "MaximumUOM", itemInfo.InventoryUom,
                                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE",
                                        "AllowZero", false,
                                        "AdditionalInfo", customerInfo
                                        ));

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantitiesEntered"))
                    {
                        PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                        //build the list of packaging quantities
                        foreach (PackagingTypeInfo infoForQty in screenListOfPackagingTypeInfos.PackagingTypeInfoList.Values)
                        {
                            quantity += (infoForQty.Quantity * infoForQty.QuantityPerPack);
                        }

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                    }
                    #endregion
                }
                else
                {
                    #region QUANTITY NO PACKAGING TYPE

                    //no packaging types, so enter quantity on 'normal' way

                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                        "BarcodeController", barcodeController,
                        "ItemDescription", itemDescription,
                        "ItemCode", itemInfo.ItemCode,
                        "ItemBarcode", itemInfo.CodeBars,
                        "BarcodesAndUomQuantities", itemInfo.PurchaseBarcodesAndUomQuantities,
                        "InitialQuantity", initialQuantity != 0 ? initialQuantity : itemInfo.DefaultQuantityOnLogisticUnit > 0 ? itemInfo.DefaultQuantityOnLogisticUnit : 1,
                        "InnerQuantity", numberOfItemsInPurchaseUnit.Value,
                        "MaximumQuantity", maxQuantity,
                        "NumberOfDigitsAfterDecimal", itemInfo.UomDecimals,
                        "InnerUOM", itemInfo.InventoryUom,
                        //"UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                        "UOM", (numberOfItemsInPurchaseUnit.HasValue && numberOfItemsInPurchaseUnit.Value != 1) ? itemInfo.PurchaseUom : itemInfo.InventoryUom,
                        "BatchNumber", batchNumber,
                        "BestBeforeDate", bestBeforeDate,
                        "SSCC", targetSSCC,
                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                        "StillToQuantity", Math.Round(stillToReceiveQuantity / numberOfItemsInPurchaseUnit.Value, itemInfo.UomDecimals),
                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE",
                        "GS1WeightAI", itemInfo.BarcodeType == PmxBarcodeTypes.VariableGTIN ? itemInfo.UomGS1MeasureType : 0,
                        "AdditionalInfo", customerInfo
                        ));

                    msg = WaitForMessage();
                    goBack = false;
                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        quantity = ExtractParameter<double>(msg.Parameters, "quantity");

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        goto Step_GoBackOnEnterQuantity;

                    }
                }

                #endregion

            }

        Step_GoBackOnEnterQuantity:

            //go back

            goBack = true;

            if (itemInfo.HasBestBeforeDate)
            {
                goto Step_BestBeforeDate;
            }
            else if (itemInfo.HasSecondBatchNumber)
            {
                goto Step_SecondBatchNumber;
            }
            else if (itemInfo.HasBatchnumber)
            {
                goto Step_SelectBatchNumber;
            }

            goto Step_IdentifyProduct;



        #endregion

        Step_CheckQuantity:

            #region CHECK QUANTITY

        //    //if allowed, check the serial numbers
        //    if (checkDataInUDFPOLine && isPOManuallySelected && serialNumbersToCheck.Count > 0 &&
        //        (itemInfo.HasSerialNumber || itemInfo.HasSAPSerialNumber))
        //    {
        //        bool failedCheck = false;
        //        foreach (string serialNumber in listOfSerialNumbers)
        //        {
        //            failedCheck = !serialNumbersToCheck.Contains(serialNumber);
        //            if (failedCheck)
        //                break;
        //        }

        //        if (failedCheck)
        //        {
        //            //ask user what to do
        //            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
        //                DefaultCultureInfo.Get(), BuildParamCollection(
        //                        "TitleKey", "MSG_TITLE_ENTERED_DATA_FAILED_CHECK",
        //                    "MessageKey", "MSG_QUESTION_ENTERED_DATA_FAILED_CHECK_SERIALNUMBER"));
        //            msg = WaitForMessage();

        //            if (msg.Name.EndsWith(".Yes"))
        //            {
        //                if (!(barcode != null &&
        //                    barcode.GS1DataObject != null &&
        //                    !string.IsNullOrEmpty(barcode.GS1DataObject.SerialNumber)))
        //                {
        //                    goto Step_EnterQuantity;
        //                }
        //                else if (isGS1DataEnteredOnScanLogDataScreen)
        //                {
        //                    goBack = true;
        //                    goto Step_ScanLabelStart;
        //                }
        //            }
        //            goBack = true;
        //            goto Step_IdentifyProduct;
        //        }

        //    }


        //    double qtyToCheck = 0;
        //    if ((itemInfo.ListOfPackagingTypes != null &&
        //           listOfPackagingTypeInfosForScreen != null &&
        //       listOfPackagingTypeInfosForScreen.Count > 0))
        //    {
        //        qtyToCheck = quantity;
        //        //if packaging types are entered, the quantity is in inventory uom,
        //    }
        //    else
        //    {
        //        qtyToCheck = quantity * numberOfItemsInPurchaseUnit.Value;
        //    }

        //    double fullQuantity = qtyToCheck * batchReceivingNumber;

        //    if (fullQuantity > stillToReceiveInventory &&
        //        stillToReceiveInventory > 0)
        //    {
        //        //ask user what to do
        //        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
        //            DefaultCultureInfo.Get(), BuildParamCollection(
        //                "TitleKey", "MSG_TITLE_RECEIVING_MORE_THAN_ORDERED",
        //                "MessageKey", "MSG_QUESTION_RECEIVING_MORE_THAN_ORDERED"));
        //        msg = WaitForMessage();

        //        if (msg.Name.EndsWith(".Yes"))
        //        {
        //            //re-enter the quantity
        //            goto Step_EnterQuantity;
        //        }
        //    }

        //    goto Step_PrintItemLabel;

        #endregion

        Step_AskToAddMore:

            #region ASK TO ADD MORE

            LogisticUnitItemGoodReceiptForSO logUnitItem = new LogisticUnitItemGoodReceiptForSO();
            logUnitItem.BatchNumber1 = batchNumber;
            logUnitItem.BatchNumber2 = secondBatchNumber;
            logUnitItem.BestBeforeDate = bestBeforeDate;
            logUnitItem.ItemCode = itemInfo.ItemCode;
            logUnitItem.PurchaseDocRef = purchaseDocRef;
            logUnitItem.IsLogisticCarrierForLogisticUnit = false;
            logUnitItem.IsLogisticCarrier = itemInfo.IsLogisticCarrier;
            logUnitItem.QuantityPerUom = numberOfItemsInPurchaseUnit.Value;// ((itemInfo.HasSAPSerialNumber || itemInfo.HasSerialNumber) && listOfSerialNumbers.Count > 0) ? 1 : numberOfItemsInPurchaseUnit.Value;
            logUnitItem.Quantity = quantity;
            logUnitItem.QuantityUom2 = quantityUom2;
            logUnitItem.PurchaseDocumentLineNum = purchaseOrderLineNum;
            logUnitItem.CardCode = customerCode;
            logUnitItem.CardName = customerName;
            logUnitItem.SODocEntry = salesOrderDocEntry.Value;
            logUnitItem.SODocLine = salesOrderLineNum.Value;

            if (itemInfo.HasBestBeforeDate ||
                itemInfo.HasSecondBatchNumber ||
                itemInfo.HasBatchnumber)
            {
                int? itriKey = null;
                itriKey = sboProviderService.InvokeMethodWithDbConnection<int?>(false, false, null, null, new DelegateWithPmxDbConnection<int?>(ExecuteGetCreateItemTransactionalInfoKey), itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                logUnitItem.ItemTransactionalInfoKey = itriKey;
            }


            DocumentLineRef lineRef = new DocumentLineRef(((int)SboObjectType.SalesOrder).ToString(), salesOrderDocEntry.Value, salesOrderLineNum.Value);
            lineRef.InventoryQuantity = quantity;
            soLineReferences.Add(lineRef);
            //logUnitItem.SalesDocRef = new DocumentRef( ((int)SboObjectType.SalesOrder).ToString(), salesOrderDocEntry.Value);
            //logUnitItem.SalesDocumentLineNumber = salesOrderLineNum;
            //logUnitItem.SalesDocumentLineQuantity = salesOrderQuantity;

            logUnitItem.Uom2 = quantityUom2.HasValue ? itemInfo.Uom2 : null;

            logUnitItem.ListOfSerialNumbers = listOfSerialNumbers;

            currentLogUnit.ItemsOnLogisticUnit.Add(logUnitItem);

            //check if there are still items to receive
            query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, null, null, null, whsInfo.SboWarehouseCode, sboProviderService.GetDbTool());
            dsItems = sboProviderService.RunView(true, null, null, query);

            RemoveReceivedItems(purchaseDeliveryNoteList, dsItems, currentLogUnit);

            if (this.GetNumberOfRows(dsItems) == 0)
            {
                //no more rows, so add the data
                goto Step_EnterDestinationLocation;
            }
            


            //ask user if he wants to add another item to the list
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "TitleKey", "MSG_TITLE_ADD_MORE_PRODUCTS",
                    "MessageKey", "MSG_QUESTION_ADD_MORE_PRODUCTS"));
            msg = WaitForMessage();

            if (msg.Name.EndsWith(".Yes"))
            {

                goto Step_IdentifyProduct;
            }

            goto Step_EnterDestinationLocation;
            #endregion

            Step_EnterDestinationLocation:

            #region ENTER DESTINATION LOCATION

            if (string.IsNullOrEmpty(targetStorLocCode))
            {

                query = BuildQuery.GetAllShippingDocksForCustomer(null, customerCode, customerAddress, whsInfo.PmxWarehouseCode, BuildQuery.LocationFilter.Loaded, sboProviderService.GetDbTool().CultureInfo);
                DataSet dsDestinationLocations = sboProviderService.RunView(false, null, null, query);

                if (GetNumberOfRows(dsDestinationLocations) > 0)
                {
                    defaultLocationCode = dsDestinationLocations.Tables[0].Rows[0][PmxOseDockWithWarehouseViewDefinition.Columns.Code.NAME] as string;
                }
                else
                {
                    defaultLocationCode = null;
                }

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.MoveOrder.IIdentifyLocationScreen),
                                       DefaultCultureInfo.Get(), BuildParamCollection(
                                           "InitialErrorKey", initialErrorKey,
                                           "TitleKey", "MSG_TITLE_SCAN_DESTINATION_LOCATION",
                                           "HideDefaultLocation", false,
                                           "DefaultLocation", defaultLocationCode,
                                           "AllowedButtons", new string[] { "MSG_BUTTON_SELECT_LOCATION", "MSG_BUTTON_SELECT_EMPTY_LOCATION" }
               ));
                msg = WaitForMessage();

                initialErrorKey = null;

                if (msg.Name.EndsWith(".ButtonClicked"))
                {
                    switch (ExtractParameter<string>(msg.Parameters, "buttonKey"))
                    {
                        case "MSG_BUTTON_SELECT_EMPTY_LOCATION":
                            selectLocationFilter = BuildQuery.LocationFilter.Empty;
                            break;
                        case "MSG_BUTTON_SELECT_LOCATION":
                            selectLocationFilter = BuildQuery.LocationFilter.All;
                            break;
                    }
                }
                else if (msg.Name.EndsWith(".BackRequested"))
                {
                    goto Step_IdentifyProduct;
                }
                else
                {
                    selectLocationFilter = BuildQuery.LocationFilter.All;
                }

                if (msg.Name.EndsWith(".LocationEntered"))
                {
                    dstLocationCode = ExtractParameter<string>(msg.Parameters, "locationCode");

                    query = BuildQuery.GetAllShippingDocksForCustomer(dstLocationCode, customerCode, customerAddress, whsInfo.PmxWarehouseCode, BuildQuery.LocationFilter.All, sboProviderService.GetDbTool().CultureInfo);
                    dsDestinationLocations = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(dsDestinationLocations) != 1)
                    {
                        // Inform the user with the error
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_NO_LOCATION_FOUND",
                                "NoTranslationOfMessageKey", false,
                                "ShowButton", true));
                        WaitForMessage();
                        goto Step_EnterDestinationLocation;
                    }
                    else
                    {
                        dstLocationCode = dsDestinationLocations.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name] as string;
                        goto Step_HandleDestinationLocation;
                    }
                }

                query = BuildQuery.GetAllShippingDocksForCustomer(null, customerCode, customerAddress, whsInfo.PmxWarehouseCode, selectLocationFilter, sboProviderService.GetDbTool().CultureInfo);
                dsDestinationLocations = sboProviderService.RunView(false, null, null, query);


                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_DESTINATION_LOCATION",
                    "LocationDS", dsDestinationLocations,
                    "ShowStopButton", false));

                msg = WaitForMessage();
                // Reset latest error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".LocationSelected"))
                {
                    dstLocationCode = ExtractParameter<string>(msg.Parameters, "locationCode");

                    goto Step_HandleDestinationLocation;
                }
                //go back
                goto Step_EnterDestinationLocation;
            }
            else
            {
                dstLocationCode = targetStorLocCode;
                goto Step_HandleDestinationLocation;
            }
            #endregion

            Step_HandleDestinationLocation:
            #region HANDLE DESTINATION LOCATION

            if (targetLuid == null)
            {
                targetSSCC = ExecuteMethodWithDbConnection<string>(out pmxError, sboProviderService, false, false,
                         delegate (PmxDbConnection conn, object[] parameters)
                         {
                             string sscc = null;
                             PmxLogisticUnitIDProvider luidProvider = new PmxLogisticUnitIDProvider(conn);
                             targetLuid = luidProvider.GenerateNewLogisticUnitSSCC(null, out sscc);
                             return sscc;
                         });
            }

            currentLogUnit.SSCC = targetSSCC;
            currentLogUnit.LogisticUnitId = targetLuid;

            foreach (var item in currentLogUnit.ItemsOnLogisticUnit)
            {
                item.OverrideLocationCode = dstLocationCode;
            }

            proceed = false;

            while (!proceed)
            {
                int numberOfReports = 0;

                try
                {

                    Collection<Dictionary<string, object>> listOfListOfParameters = new Collection<Dictionary<string, object>>();
                    Dictionary<string, object> listOfParameters = new Dictionary<string, object>();

                    bool isHana = IsHana(sboProviderService);

                    string tempObjType = SboObjectTypes.PurchaseOrder;
                    int tempDocEntry = -1;

                    if (purchaseDocRef != null)
                    {
                        tempObjType = purchaseDocRef.DocType;
                        tempDocEntry = purchaseDocRef.DocEntry;
                    }


                    if (isHana)
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.LUID.NAME_HANA, -1);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.CardCode.NAME_HANA, cardCode ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocObjType.NAME_HANA, tempObjType ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocEntry.NAME_HANA, tempDocEntry);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.SSCC.NAME_HANA, currentLogUnit.SSCC ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.InternalLUID.NAME_HANA, currentLogUnit.LogisticUnitId ?? -1);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.LocationCode.NAME_HANA, string.IsNullOrEmpty(currentLogUnit.SpecificLocationCode) ? dstLocationCode : currentLogUnit.SpecificLocationCode);
                    }
                    else
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.CardCode.NAME, cardCode);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocObjType.NAME, tempObjType);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocEntry.NAME, tempDocEntry);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.SSCC.NAME, currentLogUnit.SSCC);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.InternalLUID.NAME, currentLogUnit.LogisticUnitId);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.LocationCode.NAME, string.IsNullOrEmpty(currentLogUnit.SpecificLocationCode) ? dstLocationCode : currentLogUnit.SpecificLocationCode);
                    }


                    string tempItemCode = null;
                    string tempBatch = null;
                    string tempBatch2 = null;
                    DateTime? tempBestBeforeDate = null;
                    double? tempQuantity = 0;
                    Collection<PackagingTypeInfo> tempListOfPackagingTypes = null;
                    bool isFirst = true;
                    double? tempQuantityUom2 = null;

                    foreach (LogisticUnitItemGoodReceipt temp in currentLogUnit.ItemsOnLogisticUnit)
                    {
                        if (isFirst)
                        {
                            if (!temp.IsLogisticCarrierForLogisticUnit || temp.Quantity > 1)
                            {
                                //we need to fill the current data
                                tempItemCode = temp.ItemCode;
                                tempBatch = temp.BatchNumber1;
                                tempBatch2 = temp.BatchNumber2;
                                tempBestBeforeDate = temp.BestBeforeDate;
                                tempQuantity = temp.Quantity * temp.QuantityPerUom;
                                tempListOfPackagingTypes = temp.FullListOfPackagingTypes;

                                tempQuantityUom2 = temp.QuantityUom2;

                                isFirst = false;
                            }
                        }
                        else if (tempItemCode != temp.ItemCode && (!temp.IsLogisticCarrierForLogisticUnit || temp.Quantity > 1))
                        {
                            tempItemCode = null;
                            tempBatch = null;
                            tempBatch2 = null;
                            tempBestBeforeDate = null;
                            tempQuantity = null;
                            tempListOfPackagingTypes = null;
                            tempQuantityUom2 = null;
                            break;
                        }
                        else if (!temp.IsLogisticCarrierForLogisticUnit)
                        {
                            //check if bestbefore date and batchnum correspond
                            if (tempBatch != temp.BatchNumber1 ||
                                tempBatch2 != temp.BatchNumber2)
                            {
                                tempBatch = null;
                                tempBatch2 = null;
                            }

                            if (tempBestBeforeDate != temp.BestBeforeDate)
                            {
                                tempBestBeforeDate = null;
                            }

                            tempQuantity += (temp.Quantity * temp.QuantityPerUom);

                            tempQuantityUom2 += temp.QuantityUom2;
                        }
                    }


                    if (isHana)
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.Quantity.NAME_HANA, tempQuantity ?? -1);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityUom2.NAME_HANA, tempQuantityUom2 ?? -1);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber.NAME_HANA, tempBatch ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BestBeforeDate.NAME_HANA, tempBestBeforeDate ?? new DateTime(1899, 12, 30));
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.ItemCode.NAME_HANA, tempItemCode ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber2.NAME_HANA, tempBatch2 ?? String.Empty);
                    }
                    else
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.Quantity.NAME, tempQuantity);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityUom2.NAME, tempQuantityUom2);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber.NAME, tempBatch);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BestBeforeDate.NAME, tempBestBeforeDate);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.ItemCode.NAME, tempItemCode);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber2.NAME, tempBatch2);
                    }

                    string tempPackagingTypeText = null;
                    string tempQuantityByPackText = null;
                    if (tempListOfPackagingTypes != null &&
                        tempQuantity.HasValue)
                    {
                        tempPackagingTypeText = this.GetTransactionalPackagingTypesText(tempQuantity.Value, null, tempListOfPackagingTypes);
                        tempQuantityByPackText = this.GetQuantityInPackagingTypesText(tempListOfPackagingTypes);
                    }

                    if (isHana)
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PackagingTypeText.NAME_HANA, tempPackagingTypeText ?? String.Empty);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityByPackagingTypeText.NAME_HANA, tempQuantityByPackText ?? String.Empty);
                    }
                    else
                    {
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PackagingTypeText.NAME, tempPackagingTypeText);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityByPackagingTypeText.NAME, tempQuantityByPackText);
                    }

                    listOfListOfParameters.Add(listOfParameters);


                    //trigger event
                    numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null,
                     delegate (PmxDbConnection conn, object[] parameters2)
                     {
                         PmxPrintReportProvider printProv = new PmxPrintReportProvider(conn);
                         return printProv.PrintReportsForEventWithParametersCollection(PmxPrintReportEventType.ReceptionNewLogisticUnitIdentified,
                         dstLocationCode, deviceID, listOfListOfParameters, false, out askReprint);
                     });


                }
                catch (Produmex.Foundation.ProdumexException ex)
                {
                    s_log.Error(ex.ToString());
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                            "MessageAddendum", ex.Message,
                            "PmxError", ex.Error,
                            "ShowButton", true));

                    msg = WaitForMessage();
                }
                catch (Exception ex)
                {
                    s_log.Error(ex.ToString());
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                            "MessageAddendum", ex.Message,
                            "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                            "ShowButton", true));

                    msg = WaitForMessage();
                }

                if (numberOfReports > 0)
                {
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_QUESTION_REPRINT_DOCUMENT",
                            "TitleKey", "MSG_TITLE_REPRINT_DOCUMENT"
                            ));

                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".No"))
                    {
                        proceed = true;
                    }

                }
                else
                {
                    proceed = true;
                }

            }
            

         

            purchaseDeliveryNoteList.Add(currentLogUnit);            

            currentLogUnit = new LogisticUnitGoodsReceipt();

            if (receiveAfterLocationScan)
            {
                receiveAfterLocationScan = false;
                goto Step_ReceiveItems;
            }

            goto Step_ScanLabel;
            #endregion

            Step_ReceiveItems:
            #region RECEIVE ITEMS

            /// receive items
            /// 
            KeyValuePair<Collection<DocumentRef>, Collection<int>> listOfGeneratedDocEntry = new KeyValuePair<Collection<DocumentRef>, Collection<int>>();

            string firstLocationCode = null;

            try
            {
                listOfGeneratedDocEntry = sboProviderService.InvokeMethodWithDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(true, false, null, null, new DelegateWithPmxDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(
                delegate (PmxDbConnection conn, object[] parameters)
                {
                    PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);

                    Dictionary<string, PmxParameterValue> overruleParams = null;
                    overruleParams = new Dictionary<string, PmxParameterValue>();

                    listOfGeneratedDocEntry = prov.AddPurchaseDeliveryNoteListOfLogisticUnits(cardCode, dockCode, purchaseDeliveryNoteList, null, null, null, overruleParams, false);

					PmxInventoryLockingDetailProvider lockProv = new PmxInventoryLockingDetailProvider(conn);

                    //string dstLocation = (string)parameters[1];

                    foreach (LogisticUnitGoodsReceipt deliveryNote in purchaseDeliveryNoteList)
                    {
                        foreach (LogisticUnitItemGoodReceiptForSO item in deliveryNote.ItemsOnLogisticUnit)
                        {
                            if (string.IsNullOrEmpty(firstLocationCode))
                            {
                                //Set location code to set as dock for pick list
                                firstLocationCode = item.OverrideLocationCode;
                            }
                            //{
                            using (PmxInventoryLockingDetail lockDetail = lockProv.GetNewBO())
                            {
                                lockDetail.CardCode = item.CardCode;
                                lockDetail.CardName = item.CardName;
                                lockDetail.InventoryLockingLevel = PmxInventoryLockingLevel.ItemLUID;
                                lockDetail.InventoryLockStatusCode = PmxInventoryLockingStatusCodes.RESERVED_CODE;
                                lockDetail.ItemCode = item.ItemCode;
                                lockDetail.ItemTransactionalInfoKey = item.ItemTransactionalInfoKey;
                                lockDetail.LogisticUnitIdentKey = deliveryNote.LogisticUnitId;
                                lockDetail.PmxWhsCode = whsInfo.PmxWarehouseCode;
                                lockDetail.QualityStatusCode = PmxQualityStatusCodes.RELEASED_CODE;
                                lockDetail.Quantity = item.Quantity;
                                //lockDetail.StorageLocationCode = dockCode;

                                lockDetail.QuantityUom2 = item.QuantityUom2;// PmxItemAllConnectionsProvider.CalculateWeightFromPieces(lockDetail.Quantity, lockInfo.ItemInfo);
                                lockDetail.Uom2 = item.Uom2;

                                lockDetail.BaseEntry = item.SODocEntry;
                                lockDetail.BaseType = ((int)SboLinkDocumentType.SalesOrder).ToString();
                                lockDetail.BaseLine = item.SODocLine;

                                lockProv.AddBO(lockDetail);
                            }
                        }
                    }

                    return listOfGeneratedDocEntry;
                }));
            }
            catch (Exception ex)
            {
                //Ask if 
                s_log.Error("", ex);
                if (!(ex is ProdumexException) || ((ProdumexException)ex).Error == null)
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", ExceptionHelper.Format(ex, this.DefaultCultureInfo),
                            "NoTranslationOfMessageKey", true,
                            "IsError", true,
                            "ShowButton", true));
                    WaitForMessage();

                }
                else
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "PmxError", ((ProdumexException)ex).Error,
                            "ShowButton", true));
                    WaitForMessage();
                }
                //retry?
                //ask user if he wants to retry
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_RETRY_UPDATE",
                        "MessageKey", "MSG_QUESTION_AN_ERROR_OCCURED_WANT_RETRY"));
                msg = WaitForMessage();

                if (msg.Name.ToLower().EndsWith(".yes"))
                {
                    goto Step_ReceiveItems;
                }

                goto Step_StartReceiving;

                

            }

            purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();

            #endregion RECEIVE ITEM

            Step_PickItems:
            #region PICK ITEMS

            try
            {
                bool retValue = sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(
                delegate (PmxDbConnection conn, object[] parameters)
                {
                    PmxPickListProposalProvider plpProv = new PmxPickListProposalProvider(conn);
                    PmxPickListProvider plProv = new PmxPickListProvider(conn);
                    PmxInventoryProvider invProv = new PmxInventoryProvider(conn);

                    Collection<DocumentRef> salesOrderDocEntries = new Collection<DocumentRef>();

                    salesOrderDocEntries = new Collection<DocumentRef>(soLineReferences.Select(x => x.DocEntry).Distinct().Select(x => new DocumentRef(SboObjectType.SalesOrder, x)).ToList());
                    // salesOrderDocEntries.Add(new DocumentRef(SboObjectType.SalesOrder, salesOrderDocEntry));
                    Dictionary<string, PmxParameterValue> overruleParams = null;
                    overruleParams = new Dictionary<string, PmxParameterValue>();

                    Collection<DocumentRef> salesOrdersInError = new Collection<DocumentRef>();

                    string pickListDock = firstLocationCode;
                    if (string.IsNullOrEmpty(pickListDock))
                    {
                        pickListDock = dockCode;
                    }

                    Collection<int> generatedPickListProposalDocEntries = plpProv.GeneratePickListProposalsForSalesOrders(salesOrderDocEntries, soLineReferences.ToList(), whsInfo.PmxWarehouseCode, pickListDock, null, overruleParams, out salesOrdersInError);
                    if (generatedPickListProposalDocEntries.Count > 0)
                    {
                        Collection<int> generatedPickListDocEntries = plProv.GeneratePickListWave(generatedPickListProposalDocEntries);

                        if (generatedPickListDocEntries.Count > 0)
                        {
                            int? generatedPickListDocEntry = generatedPickListDocEntries[0];

                            foreach (int plDocEntry in generatedPickListDocEntries)
                            {
                                plProv.MakePicklistReadyFromDocEntry(plDocEntry);
                            }

                            foreach (int plDocEntry in generatedPickListDocEntries)
                            {
                                using (PmxPickList pl = plProv.GetBO(plDocEntry))
                                {
                                    //int? newLUID = null;
                                    foreach (PmxPickListLine line in pl.Lines)
                                    {

                                        PickingItemInfo pickItemInfo = new PickingItemInfo();
                                        pickItemInfo.PickListDocEntry = line.DocEntry.Value;
                                        pickItemInfo.PickListLineID = line.LineNum.Value;
                                        pickItemInfo.ItemCode = line.ItemCode;
                                        pickItemInfo.ItemDescription = line.ItemDescription;
                                        pickItemInfo.CustomItemDescription = line.ItemDescription;
                                        pickItemInfo.ItemTransactionalInfoKey = line.ItemTransactionalInfoKey;
                                        pickItemInfo.QualityStatusCode = line.QualityStatusCode;
                                        pickItemInfo.Quantity = line.Quantity;  // Get everything
                                        pickItemInfo.QuantityPerUom = line.QuantityPerUom;
                                        pickItemInfo.Uom = line.Uom;
                                        pickItemInfo.LocationCode = line.StorageLocationCode;//  
                                        pickItemInfo.LogisticUnitIdentKey = line.LogisticUnitIdentKey;

                                        if (pickItemInfo.LogisticUnitIdentKey.HasValue)
                                        {
                                            pickItemInfo.IsFullPallet = invProv.IsFullMonoPallet(pickItemInfo.LogisticUnitIdentKey.Value, pickItemInfo.ItemCode, pickItemInfo.Quantity);
                                        }


                                        pickItemInfo.QuantityUom2 = line.QuantityUom2;

                                        //Only pick when location is set
                                        //if location is not set, the stock is probably not on a pick location
                                        if (!string.IsNullOrEmpty(pickItemInfo.LocationCode))
                                        {
                                            PickedResultInfo pickResult = plProv.PickItem(pickItemInfo, plDocEntry, pickItemInfo.LogisticUnitIdentKey, pickItemInfo.LocationCode, null, pickItemInfo.IsFullPallet, false, null, false, null, false);

                                            //if (!pickItemInfo.IsFullPallet)
                                            //{
                                            //    newLUID = pickResult.LUID;
                                            //}

                                            SboRecordsetHelper.RunQueryNoReturn(s_log, SboCommands.SetLogUnitReadyForShipping(pickResult.LUID??-1, true, conn.DbTool), conn);
                                        }


                                    }  // foreach ( PmxPickListLine line in pl.Lines )
                                }  // Using ( PmxPickList pl = plProv.GetBO( plDocEntry ) )
                            }
                        }
                    }

                    return true;
                }));
            }
            catch (Exception ex)
            {
                //Ask if 
                s_log.Error("", ex);
                if (!(ex is ProdumexException) || ((ProdumexException)ex).Error == null)
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", ExceptionHelper.Format(ex, this.DefaultCultureInfo),
                            "NoTranslationOfMessageKey", true,
                            "IsError", true,
                            "ShowButton", true));
                    WaitForMessage();

                }
                else
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "PmxError", ((ProdumexException)ex).Error,
                            "ShowButton", true));
                    WaitForMessage();
                }

                //retry?
                //ask user if he wants to retry
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_RETRY_UPDATE",
                        "MessageKey", "MSG_QUESTION_AN_ERROR_OCCURED_WANT_RETRY"));
                msg = WaitForMessage();

                if (msg.Name.ToLower().EndsWith(".yes"))
                {
                    goto Step_PickItems;
                }
            }

            soLineReferences = new Collection<DocumentLineRef>();

            {
                proceed = false;
                while (!proceed)
                {
                    int numberOfReports = 0;

                    try
                    {

                        foreach (DocumentRef docRef in listOfGeneratedDocEntry.Key)
                        {

                            numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null,
                         delegate (PmxDbConnection conn, object[] parameters2)
                         {
                             PmxPrintReportProvider printProv = new PmxPrintReportProvider(conn);
                             return printProv.PrintReportsForEvent(PmxPrintReportEventType.ReceptionPurchaseDeliveryNoteCreated,
                             dockCode, deviceID, docRef.DocEntry, out askReprint);
                         });

                        }//foreach
                    }
                    catch (Produmex.Foundation.ProdumexException ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", ex.Error,
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }
                    catch (Exception ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }

                    if (numberOfReports > 0)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_QUESTION_REPRINT_DOCUMENT",
                                "TitleKey", "MSG_TITLE_REPRINT_DOCUMENT"
                                ));

                        msg = WaitForMessage();

                        if (msg.Name.EndsWith(".No"))
                        {
                            proceed = true;
                        }

                    }
                    else
                    {
                        proceed = true;
                    }

                }
            }




            goto Step_SelectDock;

            #endregion
        }




		#endregion


		#region HELPERS


		/// <summary>
		/// Executes the is SSCC valid.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="parameters">The parameters.</param>
		/// <returns></returns>
		private static bool ExecuteIsSSCCValid(PmxDbConnection conn, object[] parameters)
		{
			PmxSSCCProvider ssccProv = new PmxSSCCProvider(conn);
			return ssccProv.IsValidChecksumSSCC((string)parameters[0]);
		}

		/// <summary>
		/// Executes the get LUID by SSCC.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="parameters">The parameters.</param>
		/// <returns></returns>
		private static int ExecuteGetLUIDBySSCC(PmxDbConnection conn, object[] parameters)
		{
			PmxLogisticUnitIDProvider prov = new PmxLogisticUnitIDProvider(conn);
			return prov.GetLUIDBySSCC((string)parameters[0], false);
		}

		/// <summary>
		/// Checks if there are Products the on barcode.
		/// </summary>
		/// <param name="BarcodeContainerObject">The barcode container object.</param>
		/// <returns>
		/// True, if there is a product on the barcode, false if not
		/// </returns>
		public bool IsProductOnBarcode(BarcodeContainer BarcodeContainerObject)
		{
			if (BarcodeContainerObject != null &&
				(!string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(BarcodeContainerObject)) || !string.IsNullOrEmpty(BarcodeContainerObject.ItemCode)))
			{
				return true;
			}
			else
			{
				return false;
			}
		}


		/// <summary>
		/// Checks if there is an SSCC the on barcode.
		/// </summary>
		/// <param name="GS1DataScanned">The G s1 data scanned.</param>
		/// <returns>
		/// True, if there is an sscc on the barcode, false if not
		/// </returns>
		public bool IsSSCCOnBarcode(GS1Data GS1DataScanned)
		{
			if (GS1DataScanned != null &&
				(GS1DataScanned.Sscc != null))
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// Gets the transactional packaging types text.
		/// </summary>
		/// <param name="quantity">The quantity.</param>
		/// <param name="uom">The uom.</param>
		/// <param name="listOfTransactionalPackagingTypes">The list of transactional packaging types.</param>
		/// <returns></returns>
		private string GetTransactionalPackagingTypesText(double quantity, string uom, Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return string.Format("# {0} {1}", quantity.ToString(), uom);
            }

            //we found packagingTypes
            double currentQty = quantity;
            StringBuilder sb = new StringBuilder();
            string separator = "";
            //loop from end
            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count; iLoop++)
            {
                double qty = currentQty / listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                qty = Math.Floor(qty);


                sb.AppendFormat("{0}{1} {2}",
                    separator, qty.ToString(), listOfTransactionalPackagingTypes[iLoop].PackagingTypeName);

                currentQty -= qty * listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();


        }


        /// <summary>
        /// Gets the quantity in packaging types text.
        /// </summary>
        /// <param name="listOfTransactionalPackagingTypes">The list of transactional packaging types.</param>
        /// <returns></returns>
        private string GetQuantityInPackagingTypesText(Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return null;
            }

            //we found packagingTypes
            StringBuilder sb = new StringBuilder();
            string separator = "";



            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count - 1; iLoop++)
            {

                sb.AppendFormat("{0}1 {1} = {2} {3}", separator, listOfTransactionalPackagingTypes[iLoop].PackagingTypeName, listOfTransactionalPackagingTypes[iLoop].QuantityPerPack / listOfTransactionalPackagingTypes[iLoop + 1].QuantityPerPack, listOfTransactionalPackagingTypes[iLoop + 1].PackagingTypeName);


                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();

        }

        /// <summary>
        /// Determines whether this instance is hana.
        /// </summary>
        /// <returns></returns>
        private bool IsHana(ISboProviderService sboProviderService)
        {
            bool isHana = sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(
                delegate (PmxDbConnection conn, object[] parameters)
                {
                    return conn.DbTool.DbServerType == DbServerType.HANA;
                }));
            return isHana;
        }


        private void RemoveReceivedItems(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, DataSet dsProducts, LogisticUnitGoodsReceipt currentLogUnit)
        {
            if (currentLogUnit != null)
            {
                purchaseDeliveryNoteList.Add(currentLogUnit);
            }

            foreach (LogisticUnitGoodsReceipt logUnit in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt logUnitItem in logUnit.ItemsOnLogisticUnit)
                {
                    if (dsProducts != null &&
                        dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
                    {
                        string filter = ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + logUnitItem.ItemCode + "' ";
                        filter += " AND " + SboPurchaseOrderLineTable.Columns.DocEntry.NAME + " = " + DataSetCommandHelper.FormatAndEscapeColumnValue(logUnitItem.PurchaseDocRef.DocEntry, CultureInfo.InvariantCulture);
                        filter += " AND " + SboPurchaseOrderLineTable.Columns.LineNum.NAME + " = " + DataSetCommandHelper.FormatAndEscapeColumnValue(logUnitItem.PurchaseDocumentLineNum, CultureInfo.InvariantCulture);

                        DataRow[] rows = dsProducts.Tables[0].Select(filter);
                        double alreadyReceived = logUnitItem.Quantity;
                        for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                        {
                            double salesInvoiceQuantity = Convert.ToInt32(rows[iLoop][PmxPurchaseOrderLineTable.Columns.OpenInvQty.NAME]);

                            if (salesInvoiceQuantity <= alreadyReceived)
                            {
                                //no more quantity to receive, so delete the entry
                                rows[iLoop].Delete();
                            }
                            else
                            {
                                //reduce the quantity

                                rows[iLoop][PmxPurchaseOrderLineTable.Columns.OpenInvQty.NAME] =  salesInvoiceQuantity - alreadyReceived;
                            }

                        }
                        dsProducts.AcceptChanges();
                    }
                }
            }

            if (currentLogUnit != null)
            {
                purchaseDeliveryNoteList.Remove(currentLogUnit);
            }
        }

        /// <summary>
        /// Executes the get item info.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxItemInfo ExecuteGetItemInfo(PmxDbConnection conn, object[] parameters)
        {
            PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);
            return prov.GetCachedItemInfo((string)parameters[0]);
        }

        private static bool ExecuteIsLocationLocked(PmxDbConnection conn, object[] parameters)
        {
            PmxOseStorageLocationProvider prov = new PmxOseStorageLocationProvider(conn);
            return prov.IsLocationLocked((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get allow to select batches.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteGetAllowToSelectBatches(PmxDbConnection conn, object[] parameters)
        {
            PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);

            return prov.AllowToSelectBatches();
        }

        /// <summary>
        /// Executes the generate batch number1 for reception.
        /// </summary>
        /// <param name="conn">The connection.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static GeneratedBatchNumberReception ExecuteGenerateBatchNumber1ForReception(PmxDbConnection conn, object[] parameters)
        {
            PmxBatchNumberReceptionProvider prov = new PmxBatchNumberReceptionProvider(conn);
            if ((bool)parameters[4])
            {
                return prov.GenerateBatchNumber1ForReception((DocumentRef)parameters[0], (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
            else
            {
                return prov.GenerateBatchNumber2ForReception((DocumentRef)parameters[0], (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
        }

        private int GetNumberOfRows(DataSet ds)
        {
            if (ds != null && ds.Tables.Count > 0)
            {
                return ds.Tables[0].Rows.Count;
            }
            return 0;
        }

        private T ExecuteMethodWithDbConnection<T>(out ProdumexError pmxError, ISboProviderService sboProviderService, bool useSboConnection, bool useUserNameOfConnectionString, DelegateWithPmxDbConnection<T> methodDelegate, params object[] parameters)
        {
            T result = default(T);
            pmxError = null;

            try
            {
                result = sboProviderService.InvokeMethodWithDbConnection<T>(useSboConnection, useUserNameOfConnectionString, null, null,
                    methodDelegate, parameters);
            }
            catch (TargetInvocationException ex)
            {
                MethodInfo methodInfo = methodDelegate.Method;
                if (ex.InnerException is ProdumexException)
                {
                    s_log.Warn("Execute -- The invoked method threw a produmex exception: ", ex.InnerException);
                    pmxError = ((ProdumexException)ex.InnerException).Error;
                }
                else if (ex.InnerException == null)
                {
                    s_log.Warn("Execute -- The invoked method threw an exception: ", ex);
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
                }
                else
                {
                    s_log.Warn("Execute -- The invoked method threw a TargetInvocationException with inner exception: ", ex.InnerException);
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.InnerException.Message);
                }
            }
            catch (TransactionAbortedException ex)
            {
                s_log.Error("", ex);
                MethodInfo methodInfo = methodDelegate.Method;
                pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.InnerException == null ? ex.Message : ex.InnerException.Message);
            }
            catch (ProdumexException ex)
            {
                s_log.Error("", ex);
                if (ex.Error != null)
                {
                    pmxError = ex.Error;
                }
                else
                {
                    MethodInfo methodInfo = methodDelegate.Method;
                    pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
                }
            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
                MethodInfo methodInfo = methodDelegate.Method;
                pmxError = Produmex.Foundation.Wwf.Sbo.ProdumexErrors.ExceptionInvokingSboMethod(s_log, methodInfo, ex.Message);
            }

            return result;
        }

        /// <summary>
        /// Executes the generate BBD for reception.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static GeneratedBestBeforeDateReception ExecuteGenerateBBDForReception(PmxDbConnection conn, object[] parameters)
        {
            PmxGeneralProvider genProv = new PmxGeneralProvider(conn);
            if (parameters.Length > 1)
            {
                return genProv.GenerateBestBeforeDateForReception((string)parameters[0], (DateTime?)parameters[1]);
            }
            else
            {
                return genProv.GenerateBestBeforeDateForReception((string)parameters[0], null);
            }
        }

        /// <summary>
        /// Checks if allow to calculate based on manufacturing date.
        /// </summary>
        /// <param name="conn">The connection.</param>
        /// <returns></returns>
        private static bool ExecuteCheckIfAllowToCalculateBasedOnManufacturingDate(PmxDbConnection conn, object[] parameters)
        {
            PmxGeneralProvider genProv = new PmxGeneralProvider(conn);
            return genProv.CheckIfAllowToCalculateBasedOnManufacturingDate();

        }

        private string GetCustomerInfo(DataSet dsCustomerInfo)
        {
            string info = null;

            if (this.GetNumberOfRows(dsCustomerInfo) > 0)
            {
                string newLine = "";
                info = "";
                foreach (DataRow row in dsCustomerInfo.Tables[0].Rows)
                {
                    string numAtCard = row[SboSalesOrderTable.Columns.NumAtCard.NAME] as string;
                    if (!string.IsNullOrEmpty(numAtCard))
                    {
                        numAtCard = "(" + numAtCard + ")";
                    }
                    info += string.Format("{4}{0}({1}) - {2}{3}",
                        row[SboSalesOrderTable.Columns.CardName.NAME],
                        row[SboSalesOrderTable.Columns.CardCode.NAME],
                        row[SboSalesOrderTable.Columns.DocNum.NAME],
                        numAtCard,
                        newLine);

                    newLine = Environment.NewLine;
                }
            }

            return info;
        }
        /// <summary>
        /// Gets the name of the pack type.
        /// </summary>
        /// <param name="packagingTypeCode">The packaging type code.</param>
        /// <param name="listOfPackagingTypes">The list of packaging types.</param>
        /// <returns></returns>
        private static string GetPackTypeName(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.PackagingTypeName;
                    }
                }
            }

            return null;
        }

        /// <summary>
        /// Gets the pack barcode.
        /// </summary>
        /// <param name="packagingTypeCode">The packaging type code.</param>
        /// <param name="listOfPackagingTypes">The list of packaging types.</param>
        /// <returns></returns>
        private static Collection<string> GetPackBarcode(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        if (packType.Barcodes.Count > 0)
                        {
                            return packType.Barcodes;
                        }
                        else
                        {
                            return null;
                        }
                    }
                }
            }

            return null;
        }

        /// <summary>
        /// Executes the get create item transactional information key.
        /// </summary>
        /// <param name="conn">The connection.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int? ExecuteGetCreateItemTransactionalInfoKey(PmxDbConnection conn, object[] parameters)
        {
            PmxItemTransactionalInfoProvider prov = new PmxItemTransactionalInfoProvider(conn);
            string itemCode = (string)parameters[0];
            string batchNumber = (string)parameters[1];
            string batchNumber2 = (string)parameters[2];
            DateTime? bbd = (DateTime?)parameters[3];

            return prov.GetCreateItemTransactionalInfoKey(itemCode, batchNumber, batchNumber2, bbd);
        }

        private Collection<ItemTransactionalPackagingTypeInfo> SetItemTransactionalPackagingTypeInfoList(PmxItemInfo itemInfo)
        {
            //get the packaging types qty from item
            Collection<ItemTransactionalPackagingTypeInfo> listOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();

            foreach (PmxItemPackagingTypeInfo packInfo in itemInfo.ListOfPackagingTypes)
            {
                ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                newPackInfo.PackagingTypeCode = packInfo.PackagingTypeCode;
                newPackInfo.Quantity = packInfo.Quantity;
                newPackInfo.ItemCode = itemInfo.ItemCode;

                listOfTransactionalPackagingTypeInfos.Add(newPackInfo);

            }

            return listOfTransactionalPackagingTypeInfos;
        }

        /// <summary>
        /// Gets the hide during entering quantity.
        /// </summary>
        /// <param name="packagingTypeCode">The packaging type code.</param>
        /// <param name="listOfPackagingTypes">The list of packaging types.</param>
        /// <returns></returns>
        private static bool GetHideDuringEnteringQuantity(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.HideDuringEnteringQuantity;
                    }
                }
            }

            return true;
        }

        /// <summary>
        /// Gets the transactional packaging info.
        /// </summary>
        /// <param name="purchaseDeliveryNoteList">The purchase delivery note list.</param>
        /// <param name="batchNumber">The batch number.</param>
        /// <param name="secondBatchNumber">The second batch number.</param>
        /// <param name="bestBeforeDate">The best before date.</param>
        /// <param name="itemCode">The item code.</param>
        /// <returns></returns>
        private static Collection<ItemTransactionalPackagingTypeInfo> GetTransactionalPackagingInfo(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, string batchNumber, string secondBatchNumber, DateTime? bestBeforeDate, string itemCode)
        {
            //does it exist in the just received items?
            foreach (LogisticUnitGoodsReceipt receipt in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt receiptItem in receipt.ItemsOnLogisticUnit)
                {
                    if (batchNumber == receiptItem.BatchNumber1 &&
                        secondBatchNumber == receiptItem.BatchNumber2 &&
                        bestBeforeDate == receiptItem.BestBeforeDate &&
                        itemCode == receiptItem.ItemCode)
                    {
                        //we found the packagingData
                        return receiptItem.ListOfPackagingTypes;
                    }
                }
            }
            return null;
        }
        private static PmxOseWarehouseInfo ExecuteGetPmxWarehouseCode(PmxDbConnection conn, object[] parameters)
        {
            PmxOseProvider oseProv = new PmxOseProvider(conn);
            return oseProv.GetPmxWarehouseInfo((string)parameters[0]);
        }
        #endregion

        #region BUILD QUERY
        private class BuildQuery
        {

            internal enum LocationFilter
            {
                All = 0,
                Empty = 1,
                Loaded = 2,
            }

            /// <summary>
            /// Gets the existing ITRI.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="batchNumber">The batch number.</param>
            /// <param name="batchNumber2">The batch number2.</param>
            /// <param name="bestBeforeDate">The best before date.</param>
            /// <returns></returns>
            public static string GetExistingITRI(string itemCode, string batchNumber, string batchNumber2, DateTime? bestBeforeDate)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));

                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));



                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.ItemCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

                if (!string.IsNullOrEmpty(batchNumber))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber, CultureInfo.InvariantCulture));
                }

                if (!string.IsNullOrEmpty(batchNumber2))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber2, CultureInfo.InvariantCulture));
                }

                if (bestBeforeDate.HasValue)
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(bestBeforeDate.Value, CultureInfo.InvariantCulture));
                }

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets all loading docks of a warehouse for live loading.
            /// </summary>
            /// <param name="oseWarehouseCode">The ose warehouse code.</param>
            /// <param name="liveLoadingCode">The live loading code.</param>
            /// <param name="cultureDatabase">The culture database.</param>
            /// <returns></returns>
            internal static string GetAllShippingDocksForCustomer(string locationCode, string cardCode, string shippingAddress, string oseWarehouseCode, LocationFilter filter, CultureInfo cultureDatabase)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME, LocationDataSet.Columns.CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME, LocationDataSet.Columns.DESCRIPTION.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, LocationDataSet.Columns.WAREHOUSECODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);
                strBuilder.Append("\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.Append("\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseDockTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);
                strBuilder.Append("\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);
                strBuilder.Append("\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);


                strBuilder.Append("\n LEFT JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxPickListLineTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListLineTable.NAME, PmxPickListLineTable.Columns.StorLocCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListLineTable.NAME, PmxPickListLineTable.Columns.PickListLineStatus.NAME);
                strBuilder.Append(" != ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxPickListStatusColumnValues.Closed.VALUE, cultureDatabase));
                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListLineTable.NAME, PmxPickListLineTable.Columns.PickListLineStatus.NAME);
                strBuilder.Append(" != ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxPickListStatusColumnValues.Shipped.VALUE, cultureDatabase));

                strBuilder.Append("\n LEFT JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxPickListTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListLineTable.NAME, PmxPickListLineTable.Columns.DocEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.DocEntry.NAME);

                //strBuilder.Append("\n LEFT JOIN ");
                //strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                //strBuilder.Append(" ON ");
                //SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME);
                //strBuilder.Append(" = ");
                //SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);

                strBuilder.Append("\n WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseDockTable.Columns.IsLoadingDock.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, cultureDatabase));
                strBuilder.Append("\n AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, cultureDatabase));              

                if (!string.IsNullOrWhiteSpace(locationCode))
                {
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(locationCode, cultureDatabase));
                }

                if (filter == LocationFilter.Empty)
                {
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.DocEntry.NAME);
                    strBuilder.Append(" IS NULL ");
                }

                if (filter == LocationFilter.Loaded)
                {
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.CardCode.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, cultureDatabase));
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.ShipToAddress.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(shippingAddress, cultureDatabase));
                }

                if (filter == LocationFilter.All)
                {
                    strBuilder.Append(" AND (");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.CardCode.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, cultureDatabase));
                    strBuilder.Append(" OR ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.CardCode.NAME);
                    strBuilder.Append(" IS NULL ) AND (");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.ShipToAddress.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(shippingAddress, cultureDatabase));
                    strBuilder.Append(" OR ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxPickListTable.NAME, PmxPickListTable.Columns.ShipToAddress.NAME);
                    strBuilder.Append(" IS NULL ) ");
                }               

                if (!string.IsNullOrEmpty(oseWarehouseCode))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(oseWarehouseCode, cultureDatabase));
                }

                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME);

                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the sales order and pick list locked stock.
            /// Locked for:
            /// * SalesOrder -&gt; used for auto-overpicking
            /// * PickList -&gt; used for auto-picking, only returns stock locked on LUID's which are received on the given PurchaseOrder
            /// </summary>
            /// <param name="purchaseOrderDocEntry">The purchase order doc entry.</param>
            /// <param name="salesOrderDocEntry">The sales order doc entry.</param>
            /// <param name="pickListDocEntries">The pick list document entries.</param>
            /// <param name="dbCulture">The db culture.</param>
            /// <returns></returns>
            internal static string GetSalesOrderAndPickListLockedStock(int purchaseOrderDocEntry, int salesOrderDocEntry, Collection<int> pickListDocEntries, CultureInfo dbCulture)
            {
                StringBuilder strBuilder = new StringBuilder();

                strBuilder.AppendFormat("SELECT {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseType.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseLine.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemCode.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.Quantity.NAME));
                strBuilder.AppendFormat(", {0}",
                    SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.QuantityUom2.NAME, PmxInventoryLockingDetailTable.Columns.QuantityUom2.NAME));
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryTotalTable.Columns.QuantityPerUom.NAME ) );
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.StorLocCode.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.QualityStatusCode.NAME));
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.Quantity.NAME ) );
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME ) );

                strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(PmxInventoryLockingDetailTable.NAME));

                //strBuilder.AppendFormat( "\r\n INNER JOIN {0}",
                //    SqlCommandHelper.EscapeTableName( PmxInventoryTotalTable.NAME ) );
                //strBuilder.AppendFormat( " ON {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemCode.NAME ) );
                //strBuilder.AppendFormat( " AND ( {0} = {1} OR ( {0} IS NULL AND {1} IS NULL ) )",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME ) );
                //strBuilder.AppendFormat( " AND {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME ) );
                //strBuilder.AppendFormat( " AND {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QualityStatusCode.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.QualityStatusCode.NAME ) );

                strBuilder.AppendFormat("\r\n WHERE ( {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1} )",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(salesOrderDocEntry, dbCulture));

                strBuilder.AppendFormat(" OR ( {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList, dbCulture));
                strBuilder.AppendFormat(" AND {0} IN ({1})",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(pickListDocEntries, dbCulture));
                strBuilder.AppendFormat(" AND {0} IN ( SELECT {1} FROM {2} WHERE {3} = {4} AND {5} = {6} ) )",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.LogUnitIdentKey.NAME),
                    SqlCommandHelper.EscapeTableName(PmxInventoryDetailTable.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.PurchaseOrder, dbCulture),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(purchaseOrderDocEntry, dbCulture));

                return strBuilder.ToString();
            }
            /// <summary>
            /// Gets the customer information.
            /// </summary>
            /// <param name="docEntry">The document entry.</param>
            /// <param name="objType">Type of the object.</param>
            /// <param name="dbTool">The database tool.</param>
            /// <returns></returns>
            public static string GetCustomerInfo(int docEntry, string objType, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.AppendFormat("SELECT DISTINCT {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.DocEntry.NAME, SboSalesOrderTable.Columns.DocEntry.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.DocNum.NAME, SboSalesOrderTable.Columns.DocNum.NAME));
                strBuilder.AppendFormat(", {0}",
                   SqlCommandHelper.EscapeTableColumnNameWithAlias(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.CardCode.NAME, SboSalesOrderTable.Columns.CardCode.NAME));
                strBuilder.AppendFormat(", {0}",
                   SqlCommandHelper.EscapeTableColumnNameWithAlias(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.CardName.NAME, SboSalesOrderTable.Columns.CardName.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.NumAtCard.NAME, SboSalesOrderTable.Columns.NumAtCard.NAME));

                if (objType == SboObjectTypes.PurchaseInvoice)
                {
                    strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(SboPurchaseInvoiceTable.NAME));

                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseInvoiceLineTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocEntry.NAME));



                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.BaseEntry.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.LineNum.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.BaseLine.NAME));
                    strBuilder.AppendFormat("\r\n AND (({0} = -1 AND {1} = {2}) OR ({0} > -1 AND {1} = {3}))",
                       SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                       SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.ObjType.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME),
                       SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));

                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseOrderTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME));
                }
                else
                {
                    strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));



                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME));
                }



                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(SboSalesOrderTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.ObjType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.Confirmed.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));




                strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                    objType == SboObjectTypes.PurchaseInvoice ? SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocEntry.NAME) : SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(docEntry, CultureInfo.InvariantCulture));


                strBuilder.AppendFormat("\r\n ORDER BY {0}",
                    SqlCommandHelper.EscapeColumnName(PmxSalesOrderTable.Columns.CardCode.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeColumnName(PmxSalesOrderTable.Columns.DocEntry.NAME));

                return strBuilder.ToString();
            }
            /// <summary>
            /// Command for getting all logistic carriers order by name
            /// </summary>
            /// <param name="onlyInStock">if set to <c>true</c> the system will get the logistic carriers that are in stock and have no products on it (LUID IS NULL)</param>
            /// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
            /// <returns>
            /// Command for getting all logistic carriers order by name
            /// </returns>
            public static string GetLogisticCarriersOrderByName(bool onlyInStock, bool filterOutFrozenItems, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

                strBuilder.Append("SELECT DISTINCT ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME, ProductDataSet.Columns.PRODUCT_CODE.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME, ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, SboItemTable.Columns.CodeBars.NAME, ProductDataSet.Columns.GTIN.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));

                strBuilder.Append("\r\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                if (onlyInStock)
                {
                    strBuilder.Append("\r\n INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                    strBuilder.Append(" ON ", strBuilder.AsIdentifier(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME));
                    strBuilder.Append(" = ", strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME));
                    strBuilder.Append(" AND ", strBuilder.AsIdentifier(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME));
                    strBuilder.Append(" IS NULL ");
                }

                strBuilder.Append("\r\n WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (filterOutFrozenItems)
                {
                    Produmex.Sbo.Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart(strBuilder, " AND ");
                }

                strBuilder.Append("\r\n ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.CustomItemDescr.NAME));

                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets all internal batches in stock.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="batchNumber">The batch number.</param>
            /// <returns></returns>
            public static string GetAllInternalBatchesInStock(string itemCode, string batchNumber)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME, TextDataSet.Columns.TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);


                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber, CultureInfo.InvariantCulture));



                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the logistic units for customer.
            /// </summary>
            /// <param name="cardCode">The card code.</param>
            /// <param name="shipToAddress">The ship to address.</param>
            /// <param name="routeKey">The route key.</param>
            /// <param name="luidToIgnore">The luid automatic ignore.</param>
            /// <param name="pmxWarehouseCode">The PMX warehouse code.</param>
            /// <param name="moveToPmxWarehouse">The move automatic PMX warehouse.</param>
            /// <returns></returns>
            public static string GetLogisticUnitsForCustomer(string cardCode, string shipToAddress, int? routeKey, int? luidToIgnore, string pmxWarehouseCode, string moveToPmxWarehouse)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPickingLUIDByCustomerViewDefinition.NAME, PmxPickingLUIDByCustomerViewDefinition.Columns.LUID.NAME, LogisticCarrierDataSet.Columns.LUID.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPickingLUIDByCustomerViewDefinition.NAME, PmxPickingLUIDByCustomerViewDefinition.Columns.SSCC.NAME, LogisticCarrierDataSet.Columns.SSCC.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPickingLUIDByCustomerViewDefinition.NAME, PmxPickingLUIDByCustomerViewDefinition.Columns.StorLocCode.NAME, LogisticCarrierDataSet.Columns.STORAGE_LOCATION_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPickingLUIDByCustomerViewDefinition.NAME, PmxPickingLUIDByCustomerViewDefinition.Columns.MasterLUID.NAME, LogisticCarrierDataSet.Columns.MASTER_LUID.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPickingLUIDByCustomerViewDefinition.NAME, PmxPickingLUIDByCustomerViewDefinition.Columns.MasterSSCC.NAME, LogisticCarrierDataSet.Columns.MASTER_SSCC.Name);


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxPickingLUIDByCustomerViewDefinition.NAME));

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.CardCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.ShipToAddress.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(shipToAddress, CultureInfo.InvariantCulture));

                if (routeKey.HasValue)
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.RouteKey.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(routeKey.Value, CultureInfo.InvariantCulture));
                }
                else
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.RouteKey.NAME));
                    strBuilder.Append(" IS NULL ");
                }

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.SSCC.NAME));
                strBuilder.Append(" IS NOT NULL ");

                if (luidToIgnore.HasValue)
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.LUID.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(luidToIgnore.Value, CultureInfo.InvariantCulture));
                }

                if (!string.IsNullOrEmpty(pmxWarehouseCode))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.PmxWhsCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(pmxWarehouseCode, CultureInfo.InvariantCulture));
                }


                if (!string.IsNullOrEmpty(moveToPmxWarehouse))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.MoveToWarehouse.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(moveToPmxWarehouse, CultureInfo.InvariantCulture));
                }
                else
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxPickingLUIDByCustomerViewDefinition.Columns.MoveToWarehouse.NAME));
                    strBuilder.Append(" IS NULL ");

                }

                return strBuilder.ToString();


            }
            /// <summary>
            /// Gets all batches in stock.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <returns></returns>
            public static string GetAllBatchesInStock(string itemCode)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME, TextDataSet.Columns.TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);


                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));


                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the customers for purchase order.
            /// </summary>
            /// <param name="poRef">The po reference.</param>
            /// <param name="poLineNum">The po line number.</param>
            /// <param name="dbTool">The database tool.</param>
            /// <returns></returns>
            public static string GetCustomersForPurchaseOrder(DocumentRef poRef, int poLineNum, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.CardCode.NAME, CustomerAddressDataSet.Columns.CUSTOMER_CODE.Name));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.CardName.NAME, CustomerAddressDataSet.Columns.CUSTOMER_NAME.Name));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.ShipToDesc.NAME, CustomerAddressDataSet.Columns.ADDRESS.Name));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.ShipToCode.NAME, CustomerAddressDataSet.Columns.ADDRESS_CODE.Name));
                strBuilder.Append(", ");
                SqlCommandHelper.AddNullColumnWithName(strBuilder, CustomerAddressDataSet.Columns.MOVE_TO_WAREHOUSE.Name);

                strBuilder.Append("\r\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxSalesOrderTable.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0} ON {1} = {2} ",
                    SqlCommandHelper.EscapeTableName(PmxSalesOrderLineTable.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME));


                strBuilder.AppendFormat("\r\n INNER JOIN {0} ON {1} = COALESCE({2}, {3}) ",
                    SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME),
                                       SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseEntry.NAME));

                strBuilder.AppendFormat("\r\n AND {0} = COALESCE({1}, {2}) ",
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.LineNum.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseLine.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseLine.NAME));

                strBuilder.AppendFormat("\r\n AND (({0} = -1 AND {1} = {2}) OR ({0} > -1 AND {1} = {3}))",
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.ObjType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));




                strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(poRef.DocEntry, dbTool.CultureInfo));

                strBuilder.AppendFormat("\r\n AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.LineNum.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(poLineNum, dbTool.CultureInfo));

                

                strBuilder.Append("\r\n GROUP BY ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.CardCode.NAME));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.CardName.NAME));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.ShipToDesc.NAME));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.ShipToCode.NAME));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocDueDate.NAME));

                strBuilder.AppendFormat("\n ORDER BY {0}",
                    SqlCommandHelper.EscapeColumnName(PmxSalesOrderTable.Columns.DocDueDate.NAME));

                return strBuilder.ToString();
            }

            /// <summary>
            /// Command for getting all products order by name
            /// </summary>
            /// <param name="vendorCode">The vendor code.</param>
            /// <param name="gtin">The gtin.</param>
            /// <param name="purchaseDocRef">The purchase doc ref.</param>
            /// <param name="cardCode">The card code.</param>
            /// <param name="packagingUnit">The packaging unit.</param>
            /// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
            /// <param name="itemCode">The item code.</param>
            /// <param name="customerCode">The customer code.</param>
            /// <param name="customerAddress">The customer address.</param>
            /// <param name="sboWarehouseCode">The sbo warehouse code.</param>
            /// <param name="dbTool">The db tool.</param>
            /// <returns>
            /// Command for getting all products order by name
            /// </returns>
            /// <exception cref="System.ArgumentException">Only PurchaseOrder or Purchase(Reserve)Invoice supported;purDocEntry.DocType</exception>
            public static string GetCodeNameItemsOrderByName(string vendorCode, string gtin, DocumentRef purchaseDocRef, string cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit packagingUnit, bool filterOutFrozenItems, string itemCode, string customerCode, string customerAddress, string sboWarehouseCode, DbTool dbTool)
            {
                string purchaseDocTable = SboPurchaseOrderTable.NAME;
                string purchaseLineTable = SboPurchaseOrderLineTable.NAME;
                string purchaseInvoiceDocTable = SboPurchaseInvoiceTable.NAME;
                string purchaseInvoiceLineTable = SboPurchaseInvoiceLineTable.NAME;

                if (purchaseDocRef != null)
                {
                    switch (purchaseDocRef.DocType)
                    {
                        case SboObjectTypes.PurchaseOrder:
                            purchaseDocTable = SboPurchaseOrderTable.NAME;
                            purchaseLineTable = SboPurchaseOrderLineTable.NAME;
                            break;
                        case SboObjectTypes.PurchaseInvoice:
                            purchaseDocTable = SboPurchaseInvoiceTable.NAME;
                            purchaseLineTable = SboPurchaseInvoiceLineTable.NAME;
                            break;
                        default:
                            throw new ArgumentException("Only PurchaseOrder or Purchase(Reserve)Invoice supported", "purDocEntry.DocType");
                    }
                }

                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.LineNum.NAME, ProductDataSet.Columns.LINE_NUMBER.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME, ProductDataSet.Columns.PRODUCT_CODE.Name);


                strBuilder.Append(", CASE");
                strBuilder.Flags(QBF.Translate);
                if (purchaseDocRef != null || !String.IsNullOrEmpty(cardCode))
                {
                    strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} || ' - ' || {1} || ' - ' || {2} ",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.SubstituteItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.Substitute.NAME));
                }
                strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} || ' - ' || {1} ",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.VendorItemDescr.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.Flags(QBF.TranslateOff);
                strBuilder.AppendFormat(" ELSE {0} END",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.Append(" AS ", SqlCommandHelper.EscapeColumnName(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name));

                strBuilder.Append(", ");
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit(strBuilder, packagingUnit, ProductDataSet.Columns.GTIN.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.HasBestBeforeDate.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.PrintItemLabelReception.NAME));


                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ManBtchNum.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticUnit.NAME));

                strBuilder.Append(", ", strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.NumberOfItemsPerPurchaseUnit.NAME));

                strBuilder.Append(", ", strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.PurchaseUom.NAME));

                strBuilder.Append(", ", strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.InventoryUom.NAME));

                strBuilder.Append(", ");
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit(strBuilder, packagingUnit, SboItemTable.Columns.CodeBars.NAME);



                if (purchaseDocRef != null )
                {
                   
                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME));
                    

                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineNum.NAME));

                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.DocEntry.NAME));

                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.ObjectType.NAME));

                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME));

                   
                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.OpenInvQty.NAME));
                    

                    strBuilder.AppendFormat(", CASE WHEN {0} = -1 THEN " + strBuilder.IFNULL + "({2}, {3}) ELSE  " + strBuilder.IFNULL + "({1}, {2}) END AS {4} ",
                        SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.UomEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.UomCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.Uom.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.InventoryUom.NAME),
                        SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.UomCode.NAME));

                }


                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemName.NAME));

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBatchNumber.NAME, ProductDataSet.Columns.BATCH1.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBatchNumber2.NAME, ProductDataSet.Columns.BATCH2.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BestBeforeDate.NAME, ProductDataSet.Columns.BEST_BEFORE_DATE.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxSerialNumber.NAME, ProductDataSet.Columns.SERIAL_NUMBER_INFO.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME, "S_" + PmxSalesOrderLineTable.Columns.DocEntry.NAME);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.LineNum.NAME, "S_" + PmxSalesOrderLineTable.Columns.LineNum.NAME);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.OpenInvQty.NAME, "S_" + PmxSalesOrderLineTable.Columns.OpenInvQty.NAME);

                strBuilder.Append("\r\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                if (purchaseDocRef != null)
                {
                    //inner join Product - PO Line
                    strBuilder.Append("\r\n INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(" ON ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.ItemCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.Columns.ItemCode.NAME));

                    //inner join PO - PO Line
                    strBuilder.Append("\r\n INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseDocTable));
                    strBuilder.Append(" ON ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseDocTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.Columns.DocEntry.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.DocEntry.NAME));

                    strBuilder.Append("\r\n LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxAlternateCatNumTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(purchaseDocTable, SboPurchaseOrderTable.Columns.CardCode.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.Substitute.NAME),
                        SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.BPCatalogNumber.NAME));

                    strBuilder.Append("\r\n LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboUomTable.NAME));
                    strBuilder.Append(" ON ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
                    strBuilder.Append(" = ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, purchaseLineTable, SboPurchaseOrderLineTable.Columns.UomEntry.NAME);
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
                    strBuilder.Append(" <> -1 ");

                }
                else if (!String.IsNullOrEmpty(cardCode))
                {
                    strBuilder.Append("\r\n LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxAlternateCatNumTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME));
                }


                //JOIN ON sales order
                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxSalesOrderLineTable.NAME));
                strBuilder.AppendFormat(" ON ({0} = {1} OR {0} = {2})",
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, PmxPurchaseOrderLineTable.Columns.PmxBaseEntry.NAME));
                strBuilder.AppendFormat(" AND ({0} = {1} OR {0} = {2})",
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.LineNum.NAME),
                   SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.BaseLine.NAME),
                   SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, PmxPurchaseOrderLineTable.Columns.PmxBaseLine.NAME));
                strBuilder.AppendFormat(" AND ({0} = {1} OR {0} = {2})",
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.ObjectType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, SboPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(purchaseLineTable, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME));

                strBuilder.AppendFormat(" AND {0} = {1}",
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.LineStatus.NAME),
                   SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxSalesOrderTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME));



                string operand = "\r\n WHERE ";
                if (!string.IsNullOrEmpty(vendorCode))
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.CardCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(vendorCode, CultureInfo.InvariantCulture));
                    operand = "\r\n AND ";
                }


                if (!string.IsNullOrEmpty(gtin))
                {
                    strBuilder.Append(operand);
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                    operand = "\r\n AND ";
                }

                if (purchaseDocRef != null)
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseDocTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocEntry.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(purchaseDocRef.DocEntry, CultureInfo.InvariantCulture));
                    operand = "\r\n AND ";

                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                    operand = "\r\n AND ";

                    if (purchaseDocRef.DocType == SboObjectTypes.PurchaseInvoice)  // Is this also valid for SboPurchaseOrderLineTable ??
                    {
                        strBuilder.Append(operand);
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseInvoiceLineTable.Columns.InventoryStatus.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                        operand = "\r\n AND ";
                    }
                }

                if (!string.IsNullOrEmpty(sboWarehouseCode))
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.WarehouseCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(sboWarehouseCode, CultureInfo.InvariantCulture));
                    operand = "\r\n AND ";
                }

                if (!string.IsNullOrEmpty(itemCode))
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));
                    operand = "\r\n AND ";
                }




                strBuilder.Append(operand);
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                operand = "\r\n AND ";


                switch (packagingUnit)
                {
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing:
                        strBuilder.Append(operand, strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.PurchaseItem.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = "\r\n AND ";
                        break;
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Sales:
                        strBuilder.Append(operand, strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.SalesItem.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = "\r\n AND ";
                        break;
                    default:
                        strBuilder.Append(operand, strBuilder.AsIdentifier(SboItemTable.NAME, SboItemTable.Columns.InventoryItem.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = "\r\n AND ";
                        break;
                }

                if (filterOutFrozenItems)
                {
                    Produmex.Sbo.Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart(strBuilder, " AND ");
                }


                strBuilder.AppendFormat("\r\n AND ({0} = {1} OR {2} = {1} )",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, CultureInfo.InvariantCulture),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME));



                if (!string.IsNullOrEmpty(customerAddress))
                {
                    strBuilder.AppendFormat("\r\n AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.ShipToAddress.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(customerAddress, CultureInfo.InvariantCulture));
                }

                if (!string.IsNullOrEmpty(customerCode))
                {
                    strBuilder.AppendFormat("\r\n AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.CardCode.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(customerCode, CultureInfo.InvariantCulture));
                }


                strBuilder.Append("\r\n ORDER BY ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductDataSet.Columns.LINE_NUMBER.Name));
                strBuilder.Append(",");
             
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name));
                return strBuilder.ToString();
            }


            /// <summary>
            /// Gets the query to get the remarks
            /// </summary>
            /// <param name="docEntry">The doc entry.</param>
            /// <param name="objType">Type of the obj.</param>
            /// <param name="viewName">Name of the view.</param>
            /// <param name="dbTool">The dbtool</param>
            /// <returns></returns>
            public static string GetRemarks(int docEntry, string objType, string viewName, DbTool dbTool)
            {
                return Produmex.Sbo.Logex.Data.SboCommands.GetReceptionRemarks(docEntry, objType, viewName, dbTool);
            }

            /// <summary>
            /// Command for getting all PO's order by PO Number
            /// </summary>
            /// <param name="cardCode">The card code.</param>
            /// <param name="gtin">The gtin.</param>
            /// <param name="crossDocking">if set to <c>true</c> [cross docking].</param>
            /// <param name="includeReserveInvoices">if set to <c>true</c> [include reserve invoices].</param>
            /// <param name="sboWarehouseCode">The sbo warehouse code.</param>
            /// <param name="dbTool">The db tool.</param>
            /// <returns>
            /// Command for getting all PO's order by PO Number
            /// </returns>
            public static string GetPOsOrderByPONumber(string cardCode, string gtin, string sboWarehouseCode, DbTool dbTool)
            {

                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.AppendFormat("SELECT DISTINCT {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.ObjType.NAME, PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocNum.NAME, PurchaseOrderDataSet.Columns.PO_NUMBER.Name));
                strBuilder.AppendFormat(", CAST( {0} AS NVARCHAR ) AS {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocNum.NAME),
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER_ASSTRING.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME, PurchaseOrderDataSet.Columns.PO_ID.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardCode.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardName.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_NAME.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.NumAtCard.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_REFERENCE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.SupplierLineRef.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_LINE_REF.Name));

                strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.ItemCode.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(SboSalesOrderTable.NAME));

                strBuilder.AppendFormat(" ON (({0} = -1 AND {1} = {2}) OR ({0} > -1 AND {1} = {3}))",
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.ObjType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME),
                   SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));

                strBuilder.AppendFormat(" AND {0} = COALESCE({1}, {2})",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.Confirmed.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

              

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                 SqlCommandHelper.EscapeTableName(SboSalesOrderLineTable.NAME));

                strBuilder.AppendFormat(" ON {0} = {1} ",
                   SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderLineTable.NAME, PmxSalesOrderLineTable.Columns.DocEntry.NAME));

                strBuilder.AppendFormat(" AND {0} = COALESCE({1}, {2})",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderLineTable.NAME, SboSalesOrderLineTable.Columns.LineNum.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseLine.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseLine.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboSalesOrderLineTable.NAME, SboSalesOrderLineTable.Columns.LineStatus.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));


                strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocStatus.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Canceled.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Confirmed.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (cardCode != null &&
                    cardCode.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.CardCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                }

                if (gtin != null &&
                    gtin.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                }

                if (!string.IsNullOrEmpty(sboWarehouseCode))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.WarehouseCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(sboWarehouseCode, CultureInfo.InvariantCulture));
                }


                strBuilder.AppendFormat(" AND ({0} = {1} OR {2} = {1})",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, CultureInfo.InvariantCulture),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.PmxBaseType.NAME));
                
                

                strBuilder.AppendFormat("\r\n ORDER BY {0}",
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER.Name));

                return strBuilder.ToString();
            }


            /// <summary>
            /// Gets the name and the code of the  location, ordered by name.
            /// </summary>
            /// <param name="isLoading">Is the dock for loading? When null, no check will be done on this value</param>
            /// <param name="isUnloading">Is the dock for unloading? When null, no check will be done on this value</param>
            /// <param name="useAnd">if set to <c>true</c> the operand between Loading and Unloading is 'AND'.
            /// Otherwise it is 'OR'.</param>
            /// <param name="pmxWarehouseCode">The PMX warehouse code.</param>
            /// <param name="deviceID">The device ID.</param>
            /// <returns>
            /// The sql statement to get the dock
            /// </returns>
            public static string GetCodeNameDockOrderByName(bool? isLoading, bool? isUnloading, bool useAnd, string pmxWarehouseCode, string deviceID)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME, LocationDataSet.Columns.CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME, LocationDataSet.Columns.DESCRIPTION.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, LocationDataSet.Columns.WAREHOUSECODE.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);


                strBuilder.Append("\r\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseDockTable.NAME));

                //inner join PmxOseDock - PmxOse
                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                //inner join PmxOseDock - PmxOseStorageLocation
                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);

                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.WarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.SboWarehouseCode.NAME);

                strBuilder.Append("\r\n AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.IsManagedByProdumex.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                strBuilder.Append("\r\n WHERE ");

                //Dock must be active
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (!String.IsNullOrEmpty(pmxWarehouseCode) || !String.IsNullOrEmpty(deviceID))
                {
                    strBuilder.Append(" AND ( ");
                    if (!String.IsNullOrEmpty(pmxWarehouseCode))
                    {
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(pmxWarehouseCode, CultureInfo.InvariantCulture));
                    }
                    if (!String.IsNullOrEmpty(deviceID))
                    {
                        if (!String.IsNullOrEmpty(pmxWarehouseCode))
                            strBuilder.Append(" OR ");

                        strBuilder.AppendFormat("{0} IN ( SELECT {1} FROM {2} WHERE {3} = {4} )",
                            SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME),
                            SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.PmxWarehouseCode.NAME),
                            SqlCommandHelper.EscapeTableName(PmxThinClientWarehouseTable.NAME),
                            SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.ParentCode.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(deviceID, CultureInfo.InvariantCulture));
                    }
                    strBuilder.Append(" )");
                }

                if (isUnloading.HasValue || isLoading.HasValue)
                {
                    strBuilder.Append(" AND (");

                    if (isUnloading.HasValue)
                    {
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsUnloadingDock.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(isUnloading.Value ? SboBooleanColumnValues.Y.VALUE : SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));
                    }

                    if (isLoading.HasValue)
                    {
                        if (isUnloading.HasValue)
                        {
                            strBuilder.Append(useAnd ? " AND " : " OR ");
                        }

                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsLoadingDock.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(isLoading.Value ? SboBooleanColumnValues.Y.VALUE : SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));
                    }

                    strBuilder.Append(" )");
                }

                strBuilder.Append("\r\n ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME);

                return strBuilder.ToString();
            }

            internal static string SetLogUnitReadyForShipping(int luid, bool ready, DbTool dbTool)
            {
                return Produmex.Sbo.Logex.Data.SboCommands.SetLogUnitReadyForShipping(luid, ready, dbTool);
            }

        }
        #endregion
    }
}
